#!/usr/bin/python
# -*- coding: utf-8 -*-
# HINWEIS 
# Ausgabestrings müssen explizit als String in utf-8 codiert werden 
# z.B. hinweis = String(hinweis,"utf-8")
# die coding Angaben funktionieren nur, wenn diese Datei auch im entsprechendem Coding abgespeichert wurde!
# ABER: beim Abspeichern im iso-8859-1 Format werden die Umlaute in den Kommentaren verramscht, was in dieser Datei passiert ist
# für die Ausgabestrings, vgl. Zeilen 510ff.

import sys
sys.path.append("BitMusterGUIv2.jar")

from java.lang import System

from java.awt.event import KeyListener, KeyEvent, KeyAdapter
from java.awt import Font

from javax.swing import JFrame
from javax.swing import (BoxLayout, GroupLayout, ImageIcon, JButton, JFrame, JPanel,
        JPasswordField, JLabel, JTextArea, JTextField, JScrollPane, JTable,
        SwingConstants, WindowConstants, JToggleButton, BorderFactory, border, JOptionPane)
        
from javax.swing import JFileChooser, UIManager, DefaultComboBoxModel
from javax.swing.filechooser import FileNameExtensionFilter     
from java.awt import Component, FlowLayout, GridLayout, BorderLayout, GridBagConstraints, Dimension, Toolkit

# Clipboard
from java.awt.datatransfer import StringSelection
from java.awt.datatransfer import Clipboard, DataFlavor
from java.awt import Toolkit

from java.awt import Color

from gamegrid import GameGrid, Actor, Location, GGBackground, GameGrid
#from gamegrid import *
import random
import java,os # wichtig für Dateicheck!
from java.io import File

# Swing thread imports
from java.lang import Runnable
from javax.swing import SwingUtilities

# Timer imports
import time
import threading
#from threading import Timer
from java.util import Timer, TimerTask
#import java.awt.event.ActionEvent;
#from java.awt.event import ActionListener;

# String f�r UTF-8 Konvertierung
from java.lang import String

# GUI Imports
import NewJFrame
import jDialogMessage
import NewOkCancelDialog
import NewJFileDialog
import NewJFileSaveDialog
import NewAboutJDialog
import JFrameBitstream
import JFrameActionButtons

"""
comment
Programm zur Veranschaulichung der Darstellung von (binärer) Informationscodierung
Diese liegen als Bitmuster in einer Datei (Vorgabe: beispiel1.txt)

"""
# Terminal Aufruf MAC OSX:
# java -Dpython.cachedir.skip=false -Dpython.cachedir=$TMPDIR -jar fojython.jar bitmuster-v1g-GRID-Layout.py
# für WINDOWS in einer run.bat:
#@echo off
#rem -Q new option: future division used
#java -Dpython.cachedir.skip=false -Dpython.cachedir=%TEMP% -jar xxjythonxxx.jar -Q new %1.py
# 

#Version v1: 4bit x 16 adressen speicher
#Version v1b: Ausgabe der Bitmuster des Bildschirms in eine Datei, bitstreams Ein-Ausgabe
#Version v1d: Zeilen beginnen bei 0 (analog zum VNR), ZUfallsbitstream erzeugen
#Version v1e: Einlesen einer Datei von Bitstreams und abspielen (GIF-Player):
# Zeilen mit # in einer Bitsreams-Datei werden ignoriert (Kommentare, Namen)

# Version v1f: TO DO : viel Aufräumen, vielleicht noch Delay Einstellungen, Start / Stop Anmimation? Buttons für komplett Weiss , komplett Schwarz
# Version v1g: Angabe der Gridgröße um auch andere Bildgrößen verarbeiten zu können - vgl. Bildungsserver, Beispieldatei wird nicht mehr benütigt
# Version v1e: Umstellung auf GUI, Eliminierung von Tasten, keine PRINT-Anweisungen mehr

# Version 2 Umstellung auf runnable thread wegen Swing etc und fehlermeldung bei Windows Start - Versuch von threadsafe
# Aufräumen und viele weitere Ergänzungen: z.B. Speicher-Operationen, Bitstream-Zufall etc.
# while true schleife gekappt, da wegen der Eventprogrammierung keinen Sinn mehr

# Version 2a: Maximierung bei Windows scheint am Anfang unnötig - rausgenommen.
# Fenster Close-Button nun abgefangen, da sonst das Proggi nicht richtig beendet wurde(?)
# Abfrage-Delay von 2000 auf 1000 reduziert, um die Response auf Benutzer-Eingabe-Close zu erhöhen
# wrapper Fkt muss offenbar verschachtelt definiert sein. In den TigerJython Einstellungen diese Fehlererkennung ausschalten!

# Version 2b:
# Fixed: Speicher wurde nach dem Laden von einer Speicher-Datei oder einer Bitstreams-Datei nicht aktualisiert angezeigt
# Fixes: Fehler beim Laden einer BitstreamS Datei wegen Index out of range, 09/23 op

# Version 2c:
# Aktueller Titel, der die geladene Datei beschreibt, jetzt überarbeitet im Speicherfenster und im Steuerungsfenster und zusätzlich als Information im Hinweis-Textfeld
# Präzisierung von Fehlermeldungen beim Laden von Dateien, die nicht in den Speicher passen
# Wenn die Datenbreite stimmt, können auch kleinere Dateien in einen groesseren Speicher geladen werden

# Version 2d:
# hauptsächlich sukzessive die Ersetzung zerschossener Umlaute
# Einlesen der BitstreamS Datei endet jetzt korrekt mit Anzeige des ersten Bitstream im Speicher
# Wiedergabe der BitstreamS endet jetzt ebenfalls mit dem ersten Bitstream im Speicher
# Menu für Wiederholungen und Anzeigedauer ergänzt und implementiert

# mögliche Erweiterungen:
# Implemnetieren der Speicheroperationen zum einen als kleine Skriptsprache in einem Extra-Fenster, z.B. mit kleinem Befehlssatz:
# SL (Shift Left), SR, RL (Rotate Left), INV, CLR, RND (Random), W1 (Wait 1 Second), W2, W05 (Wait 0.5 Seconds), erstmal ohne Schleife? oder JMP LBLA (LabelA, LabelB etc.)

# GUI erstellt mit netbeans 12.5 / 12.6 / 19 GUI-Builder
# GUI Compiler: Zulu 11.0.14

# Decorator to add a function to SwingUtilities.invokeLater donated by Alex Grönholm
class RunnableWrapper(Runnable):
    
    def __init__(self, func, *args, **kwargs):
        self.func = func
        self.args = args
        self.kwargs = kwargs
 
    def run(self):
        self.func(*self.args, **self.kwargs)

def runswing(func):
    """Schedules the given function for execution in the Event Dispatch Thread."""
    # offenbar nur diese Möglichkeit einer verschachtelten Definition möglich
    # anderer Möglichkeit der Auslagerung in eigene Fkt hat nicht funktioniert
    def wrapper(*args, **kwargs):
        SwingUtilities.invokeLater(RunnableWrapper(func, *args, **kwargs))
    return wrapper
# end of decorator function ----------------------------------------------------
    
# TEST timer handling: https://www.jython.org/jython-old-sites/docs/library/sched.html
def print_time():
     #print "From print_time", time.time()
     pass

#def print_some_times():
     #print time.time()
     #Timer(5, print_time, ()).start()
     #Timer(10, print_time, ()).start()
     #Timer.schedule(print_time, 0, 1000)
     #time.sleep(11)  # sleep in seconds while time-delay events execute
     #print time.time()

#timer = Timer
#Timer.schedule(print_time, 0, 1000)
#print_some_times()
# End Test Timer

###########  Konstanten ############
versionsnummer="2.0d"
autor = "Frank Oppermann"
lizenz = "cc-by-sa 4.0 (Frank Oppermann)"
kurzanleitung=("Programm zur Veranschaulichung der Darstellung von (binörer) Informationscodierung. Diese liegen als Bitmuster in einer Datei")

# die einzelnen Fontgroessen der Grids
DATEIFONT = Font("SansSerif",Font.PLAIN,12) # Schriftgrösse für Speichergrid
ZEILENFONT = Font("SansSerif",Font.PLAIN,12)
SPEICHERFONT = Font("SansSerif",Font.PLAIN,12) # doppel zu oben?

# Tastencodes als KONSTANTEN
ESC_TASTE = 27

B_TASTE =  66
E_TASTE =  69
G_TASTE =  71
H_TASTE =  72
N_TASTE =  78
O_TASTE =  79
Q_TASTE =  81
R_TASTE =  82
W_TASTE =  87
Z_TASTE =  90

####### UIManager wichtig am Anfang!!
# https://docs.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html

# wähle für jede Plattform das entsprechende Aussehen, Set cross-platform Java L&F (also called "Metal")
UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName())

# use the System L&F - kein Start bei MAC??
#UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName())

# Set Motif L&F on any platform
#UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel")

#print UIManager.getLookAndFeel()


# Einstellungen für den FileChooser
# der UIManager enthält viele notwendige Texteinstellungsmöglichkeiten:
# customize JFileChooser to show German labels
UIManager.put("FileChooser.lookInLabelText", "Suchen in:");
UIManager.put("FileChooser.upFolderToolTipText", "Einen Ordner aufw?rts in der Hierarchie");
UIManager.put("FileChooser.newFolderToolTipText", "Neuen Ordner anlegen");
UIManager.put("FileChooser.newFolderButtonText", "Neuer Ordner");
UIManager.put("FileChooser.fileNameLabelText", "Dateiname:");
UIManager.put("FileChooser.filesOfTypeLabelText", "Dateityp:");
UIManager.put("FileChooser.cancelButtonText", "Abbrechen");
UIManager.put("FileChooser.cancelButtonToolTipText ", "Aktion abbrechen");
UIManager.put("FileChooser.byDateText ", "nach Datum sortiert");
UIManager.put("FileChooser.saveTitleText ", "Sichern als .txt Datei");
UIManager.put("FileChooser.saveButtonToolTipText", "Den Speicher jetzt als Datei sichern");

# nur in main mit dem entsprechenden Objekt,
# wenn obige Einstellungen wärend der Laufzeit geändert werden sollen
#SwingUtilities.updateComponentTreeUI(newfiledialog.jFileChooser1);

# Diverse vordefinierte BORDERS für Components
bGreyLine = BorderFactory.createLineBorder(Color.GRAY, 1, True);
bTitled1 = BorderFactory.createTitledBorder(bGreyLine, "Length (1/2)");
#lenMicro.setBorder(bTitled1);
#bTitled2 = BorderFactory.createTitledBorder(bGreyLine, "Length (2/2)", TitledBorder.LEFT, TitledBorder.TOP);
#lenMicro.setBorder(bTitled2); 

blackline = BorderFactory.createLineBorder(Color.black);
raisedetched = BorderFactory.createEtchedBorder(border.EtchedBorder.RAISED);
loweredetched = BorderFactory.createEtchedBorder(border.EtchedBorder.LOWERED);
raisedbevel = BorderFactory.createRaisedBevelBorder();
loweredbevel = BorderFactory.createLoweredBevelBorder();
empty = BorderFactory.createEmptyBorder();
redline = BorderFactory.createLineBorder(Color.red);

# BItstream-Anzeige-Delay
BITSTREAM_ANZEIGE_DELAY = 0.1 # Angabe in Sekunden

# eigene Color-Werte
MYGREEN = Color(101,178,0)
MYRED = Color(252,137,41)

# Clipboard initialisieren
toolkit = Toolkit.getDefaultToolkit()
clipboard = toolkit.getSystemClipboard()
# beispiel zum Löschen
#clipboard.setContents(StringSelection(""), None)
#clipboard.setContents(StringSelection("Hello World!"), None)


# Check ob noch Refeerenzen aktiv
#print "start",
#try:
#    if mygrid:
#        print "vorhanden: ",
#        print mygrid
#except:
#    print "nicht vorhanden"
#    pass

# ------------------------------  Beginn der DEFINITIONEN -------------------


# ------------------------------------ Menu BEENDEN
def quitOnKlick(event): # BEENDEN Button
    
    #mainWindowClosing(event) 
    #dispose()   
    #print "beende:",mygrid
    # nur für die while true schleife
    global quitKlickBool 
    quitKlickBool = True
    
    # nur für STANDALONE!!
    #hinweistext = "Wirklich beenden? Es könnten noch ungesicherte Änderungen im Speicher sein."
    #if JOptionPane.showConfirmDialog(None, hinweistext,"Programm Codierung beenden?", JOptionPane.OK_CANCEL_OPTION) == JOptionPane.OK_OPTION:
    #        sys.exit(0)
    
    #System.exit(0)  # macht offenbar zu sys.exit(0) keinen Unterschied
    # ALLES schliessen am Ende
    
    #print mygrid
#    mygrid.dispose()
#    dateigrid.dispose()
#    zeilengrid.dispose()
    
    #cp.removeAll()
#    runswing(newJframe.removeAll())
#    runswing(newJframe.dispose())
#    
#    jframebitstream.removeAll()
#    jframebitstream.dispose()
#    
#    jframeActionButtons.removeAll()
#    jframeActionButtons.dispose()
#    
#    del mygrid
#    del dateigrid
#    del zeilengrid
#    del newJframe
#    del jframebitstream
#    del jframeActionButtons
    
    #break # unsch?n, aber hier notwendig
    
    #return

def closeAll():
    #print "in closeAll"
    # ALLES schliessen am Ende
    mygrid.dispose()
    dateigrid.dispose()
    zeilengrid.dispose()
    
    #cp.removeAll()
    newJframe.removeAll()
    newJframe.dispose()
    
    del mygrid
    del dateigrid
    del zeilenfrid
    del newJframe
    
    System.exit(0) # der Parameter 0 ist gefordert, alles andere als 0 abnormer Exit
    
def closeDialog():
    # Schliessen nach Startdialog
    
    newJframe.removeAll()
    newJframe.dispose()
    
def mainWindowClosing(event): # handles the Frame EXIT-Button
    # das Abbruch-Flag
    global quitKlickBool
    quitKlickBool = True # Abbruch-Flag setzen, leider wieder nur global möglich
    #print threading.active_count()  
    #System.exit(0)
    #print "window closing"

# wird ausgelöst, wenn auf den Close-Button gedrückt wird.    
def onCloseClicked():
    global quitKlickBool
    quitKlickBool = True # Abbruch-Flag setzen, leider wieder nur global möglich
    #System.exit(0)
##### Ende der Close Behandlungen
    
def get_os_version(): # https://stackoverflow.com/questions/23372584/jython-how-to-retrieve-the-operating-system-name
    ver = sys.platform.lower()
    if ver.startswith('java'):
        import java.lang
        ver = java.lang.System.getProperty("os.name").lower()
    return ver

#------- TEXT Datei LESEN
def textDateiEinlesen(datei, filename):
    
    dateiName = datei
    
    bitmuster = [] # enthaelt zeilenweise die bitmuster aus der Datei
    #-------TEST
    fileHandlerInput = open(dateiName)
    
    while True: # solange es noch eine Zeile zum Lesen gibt
        dateiZeile  = fileHandlerInput.readline() # lese diese
        
        if dateiZeile == "": # wenn letzte Zeile
            break # Schleife verlassen - unsch?n, aber hier am einfachsten
        #sonst
        # ?berpr?fen, ob die Zeile einen Kommentar enth?lt
        if dateiZeile.find("#")== (-1):  # wenn # NICHT enthalten ist, also, wenn keine Kommentarzeile enthalten ist
            # Zeile aufraeumen
            dateiZeile=dateiZeile.replace('\n', '') # Steuerzeichen raus
            dateiZeile=dateiZeile.replace('\r', '') # Steuerzeichen raus
            dateiZeile=dateiZeile.replace(' ', '') # Leerzeichen raus
            
            bitmuster.append(dateiZeile) # und f?ge sie zu den bitmustern hinzu
        
            if len(dateiZeile) != SPALTEN_KONST:
               
                hinweis= "FEHLER1: Die Datei  "+filename+"  entspricht nicht dem vorgegebenen Format! Die Datenbreite des Speichers betraegt "+str(len(dateiZeile))+" bit, es wurden aber "+str(SPALTEN_KONST)+" bit erwartet. \nProgramm beenden und die Speichergröße entsprechend der zu ladenden Datei neu wählen."
                #print hinweis
                # hier mal mit utf-8
                # das hat auf dem macc erst funktioniert, dann wieder nicht, wenn nicht iso8859 probieren
                #hinweis = String(hinweis,"iso-8859-1")
                hinweis = String(hinweis,"utf-8")
                
                jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
                jframeActionButtons.jTextFieldStatusBar.setBackground(MYRED)
                jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                fileHandlerInput.close()
                return -1
    # end of while
    fileHandlerInput.close()
    
    # Hinweis wenn die Datei weniger Adressen enth?lt
    if len(bitmuster) < zeilen:
        hinweis= "HINWEIS: Die Datei "+filename+" hat weniger Speicheradressen ("+str(len(bitmuster))+") als der gewählte Speicher ("+ str(zeilen) +"). Sie wurde in den Speicher eingelesen."
        #hinweis = String(hinweis,"iso-8859-1")
        hinweis = String(hinweis,"utf-8")
        
        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.ORANGE)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    
    # Hinweis und Fehler/ Abbruch, wenn zuviele Speicheradressen
    if len(bitmuster) > zeilen:
        hinweis= "FEHLER2: Die Datei "+filename+" entspricht nicht der vorgegebenen Speichergröße ("+ str(zeilen) +").! Die Anzahl der zu ladenden Speicheradressen ("+str(len(bitmuster))+") ist zu gross."
        hinweis = String(hinweis,"utf-8")
        
        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
        jframeActionButtons.jTextFieldStatusBar.setBackground(MYRED)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
        
        return -1
    
    return bitmuster 

#------- TEXT Datei ANALYSIEREN
def textDateiAnalyse(datei, filename):
    
    dateiName = datei
    
    bitmuster = [] # enthaelt zeilenweise die bitmuster aus der Datei
    #-------TEST
    fileHandlerInput = open(dateiName)
    
    anzahlZeilen=0
    letzteAnzahl = 999
    fehlerhinweis = ""
    while True: # solange es noch eine Zeile zum Lesen gibt
        dateiZeile  = fileHandlerInput.readline() # lese diese
        if dateiZeile == "": # wenn letzte Zeile
                break # Schleife verlassen - unschön, aber hier am einfachsten
        if dateiZeile.find("#")== (-1):  # wenn # NICHT enthalten ist, also, wenn keine Kommentarzeile enthalten ist
            anzahlSpalten=len(dateiZeile)
            if (letzteAnzahl!=999) and (letzteAnzahl != anzahlSpalten-1):
                fehlerhinweis = "Fehler! Die Länge der Zeilen in der Datei "+filename+" sind unterschiedlich!"
                fehlerhinweis = String(fehlerhinweis,"utf-8")
                break
            anzahlZeilen=anzahlZeilen+1
            letzteAnzahl = anzahlSpalten-1   
        # sonst mache weiter mit der n?chsten Zeile
        
    if fehlerhinweis:
        hinweis = fehlerhinweis
        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.RED)
        
    else:       
        hinweis= "Die Datei \n"+filename+" hat als Inhalt \n"+str(anzahlZeilen)+" Speicheradressen mit\nje "+str(letzteAnzahl)+" bit Datenbreite."
        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.BLACK)
    #print hinweis
    
    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    fileHandlerInput.close()
        
    # end of while
    
#    messageDialog.jLabelMessage.setText(hinweis)
#    messageDialog.jLabelMessage.setVisible(True)
#    
   
#    if len(bitmuster) != zeilen:
#        hinweis= "F2: Die Datei "+filename+" entspricht nicht dem vorgegebenen Format!"
#        
#        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
#        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.RED)
#        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
#        
#        return -1
    return hinweis

#--- BITSTREAMs Datei LESEN
def bitstreamSDateiEinlesen(dateiName, filename): # Gibt eine Liste von bitstreams zurück, ignoriert Zeilen, die # enthalten
  
    bitstreams = [] # Initialisierung, enthaelt später zeilenweise die bitmuster aus der Datei
    path = dateiName
    
    if os.path.isfile(path):
        hinweis_alt = jframeActionButtons.jTextFieldStatusBar.getText()
        hinweis = hinweis_alt+"\nDie Datei "+dateiName+" existiert und die Bitstreams werden geladen"
        #print hinweis       
        jframeActionButtons.jTextFieldStatusBar.setForeground(MYGREEN)
        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
       
        fileHandlerInput = open(dateiName)
     
        while True: # solange es noch eine Zeile zum Lesen gibt
            dateiZeile  = fileHandlerInput.readline() # lese diese
            
            if dateiZeile == "": # wenn letzte Zeile
                break # Schleife verlassen - unschön, aber hier am einfachsten
            #sonst
            # Zeile aufraeumen
            dateiZeile=dateiZeile.replace('\n', '') # Steuerzeichen raus
            dateiZeile=dateiZeile.replace('\r', '') # Steuerzeichen raus
            dateiZeile=dateiZeile.replace(' ', '') # Leerzeichen raus
            
            if dateiZeile.find("#")== (-1):  # wenn # NICHT enthalten ist
                # prüfe ob Länge stimmt
                
                if len(dateiZeile) == ZEILEN_KONST * SPALTEN_KONST: # die Länge eines Bitstreams ist die gesamte Speichergöße: Datenbreite (Spalten) * Speicheradressen (zeilen)
                    bitstreams.append(dateiZeile) # und f?ge sie zu den bitmustern hinzu
        
                else:
                    hinweis= "FEHLER2 (BitstreamS Import): Die Datei \n"+filename+" \nentspricht nicht dem vorgegebenen Format!"
                    hinweis = hinweis + "\nDer Speicher kann eine Bitstream-Laenge von "+str(ZEILEN_KONST * SPALTEN_KONST)+" bit aufnehmen."
                    hinweis = hinweis + "\nDie Datei hat jedoch eine Bitstream-Laenge von "+str(len(dateiZeile))+" bit."
                    if len(dateiZeile) == 0: # falls aus irgendwelchen Gr?nden die L?nge der Dateizeile 0 sein sollte, ignorieren wir diese...
                        break
                    else: # sonst koennen wir den folgenden Test durchfuehren
                        if ZEILEN_KONST * SPALTEN_KONST % len(dateiZeile) == 0: # wenn es ein Teiler ist, liegt vielleicht eine Speicherdatei vor.
                            hinweis = hinweis + "\nVielleicht ist dies eine Speicherdatei?" 
                    # und den Hinweis darstellen        
                    jframeActionButtons.jTextFieldStatusBar.setForeground(MYRED)
                    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
                    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                    
                    #hinweis = textDateiAnalyse(datei,filename)
        
                    messageDialog.setTitle("FEHLER2")
                    messageDialog.jTextArea1.setText(hinweis)
                    messageDialog.setVisible(True)   
    
                    return -1
            # sonst mache weiter
            
        # end while    
        fileHandlerInput.close() # Schliesse die Datei auf dem Laufwerk
     
    else:
        
        hinweis= "FEHLER: Die Datei "+dateiName+" existiert NICHT und muss vorher angelegt werden!"
        
        jframeActionButtons.jTextFieldStatusBar.setForeground(MYRED)
        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
        
        return -1

    #print (bitstreams)
    return bitstreams 

#      ----------- Datei SCHREIBEN
def textDateiSchreiben(dateiName, filename): # dateiName enth?lt auch den Pfad!! filename NUR den Dateinamen mit Endung
    hinweis=""
    bitmuster = getPicture() # enthaelt zeilenweise die bitmuster aus der Datei
    
    if dateiName != "": # wenn der Dateiname nicht leer ist, dann können die Dateioperationen ausgef?hrt werden
        path = dateiName
        
        if os.path.isfile(path):
            #print("Datei "+filename+" existiert und wird ueberschrieben")
            hinweis_alt = jframeActionButtons.jTextFieldStatusBar.getText()      
            hinweis = hinweis_alt+"\nDie Datei "+filename+" existiert und wird ueberschrieben"
            jframeActionButtons.jTextFieldStatusBar.setForeground(Color.ORANGE)
            jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
            jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
            
            fileHandlerOutput = open(dateiName, "w")
         
            for element in bitmuster:
                    #print element
                    fileHandlerOutput.write(element + "\n") # zeilenweise in die Datei schreiben
                    
            fileHandlerOutput.close() # Stream schliessen
         
        else:
            #print("Die Datei "+filename+" existiert nicht und wird angelegt!")
            my_file = open(dateiName,'w')
            for element in bitmuster:
                    my_file.write(element + "\n") # zeilenweise in die Datei schreiben
            my_file.close()
            #path.createNewFile()
            #hinweis_alt = jframeActionButtons.jTextFieldStatusBar.getText()        
            hinweis = "Die Datei \n"+filename+" \nexistiert nicht und wird angelegt!\nSpeicher wurde in die Datei geschrieben."
            jframeActionButtons.jTextFieldStatusBar.setForeground(Color.ORANGE)
            jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
            jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
            
            return -1
       
        if len(bitmuster) != zeilen:
            #print("FEHLER2: Die Datei "+filename+" entspricht nicht dem vorgegebenen Format!")
            hinweis = "FEHLER21 (Datei schreiben): \nDie Datei \n"+filename+" \nentspricht nicht dem vorgegebenen Format!"
            jframeActionButtons.jTextFieldStatusBar.setForeground(MYRED)
            jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
            jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
           
            return -1
        return bitmuster 
    #sonst 
    else:
        #print("FEHLER3: Es wurde kein Dateiname angegeben!")
        hinweis = "FEHLER3: Es wurde kein Dateiname angegeben!"
        jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
        jframeActionButtons.jTextFieldStatusBar.setBackground(MYRED)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
        return -1
        

#------- Bitmuster WEI? (Nullen) erzeugen 
def wert2bitstream(wert): # erzeugt einen Bitstream aus einer Liste von bitmustern mit wert
  
    bitstream=""
    for i in range(0, ZEILEN_KONST*SPALTEN_KONST): # 
        
        bitstream = bitstream + str(wert) # und in den bitstream integrieren
     # end for   

    return bitstream 

#------- Bitmuster ZUFALL erzeugen 
def zufall2bitstream(): # erzeugt ein zuf?lliges bitmuster der KONSTANTEN L?nge
  
    bitstream=""
    for i in range(0, ZEILEN_KONST*SPALTEN_KONST): # 
        random.seed() # ZUfallszahelngenerator initialisieren
        zufallsbit = random.randint(0, 1) # Zufallzahl(bit) 0 oder 1 generieren
        bitstream = bitstream + str(zufallsbit) # und in den bitstream integrieren
     # end for   

    return bitstream       

# ----- EVENTS  ------------------------------------------------------

# -- Noch notwendig? Tastendrücke haben keine Funktion     
def onKeyPressed(event): # der Name des Parameters, hier event, kann frei gew?hlt werden, Tastenevent abfangen
    #tasteneingabe = input("Welche Taste wurde gedrückt?")
    #print event.getKeyCode()
    pass
    
# ------- BILD Grid Event
def pressCallbackMyGrid(e): # Maus Event f?r BILDgrid abfangen
      
    mouselocation = mygrid.toLocationInGrid(e.getX(), e.getY())
    aktColor = bg.getColor(mouselocation)
    #print mouselocation
    if aktColor == Color.white:
        bg.fillCell(mouselocation,Color.black)
    else:
        bg.fillCell(mouselocation,Color.white)
        
    runswing(getPicture2()) 
    #refresh()
    runswing(zeilengrid.refresh())
    runswing(dateigrid.refresh())
    runswing(mygrid.refresh())
    runswing(newJframe.repaint())
    
    # falls vorhsanden wird der Bitstream im Bitstream Fenster aktualisiert
    if showBitstream:       
            bitstreamfield = picture2bitstream()       
            jframebitstream.jTextBitstream.setText(bitstreamfield)
    #newJframe.repaint()
    
# -------- DATEI/SPEICHER GRID Event
def pressCallbackDateiGrid(e): # Maus Event f?r DATEIgrid abfangen
     
    mouselocation = dateigrid.toLocationInGrid(e.getX(), e.getY())
    aktColor = mygrid.bg.getColor(mouselocation)
    #print mouselocation
    # ?ndere hier auch das Bild!
    if aktColor == Color.white:
        mygrid.bg.fillCell(mouselocation,Color.black) # richtig, auf mygrid!
    else:
        mygrid.bg.fillCell(mouselocation,Color.white)
        
    runswing(getPicture2())
    #refresh()
    runswing(zeilengrid.refresh())
    runswing(dateigrid.refresh())
    runswing(mygrid.refresh())
    runswing(newJframe.repaint())
    
    if showBitstream:       
            bitstreamfield = picture2bitstream()       
            jframebitstream.jTextBitstream.setText(bitstreamfield)
# end def
        
# --------------  EVENT FUNKTIONEN (Menu Speicher...) --------------------

#--------------  NEU Dialog --------------- 
# ------------------------------------ funktioniert nicht - aus Anschauungsgr?nden
def newOnKlick(event):
    #startDialog = NewOkCancelDialog(newJframe,True)
    startDialog.setLocationRelativeTo(newJframe); 
    startDialog.setVisible(True)
#    mygrid.disposeAll()
#    dateigrid.disposeAll()
#    zeilengrid.disposeAll()
    makeFrame()
    return

#--------------  LADEN Dialog ---------------      
def textDateiEinlesenOnKlick(event):
    
    # Dialog auf öffnen setzen
    newfiledialog.jFileChooser1.dialogType=JFileChooser.OPEN_DIALOG
    
    #dir_path = os.path.dirname(os.path.realpath(__file__))
    
    dir_path = os.getcwd()
    # dies ist notwendig, um den Path als String in ein jav.io.File Objekt zu casten!
    filetest = File(dir_path)
    # um diesen dann im FileChooser weiter zu verwenden
    # Hintergrund ist, dass der User immer nur das aktuelle Arbeitsverzeichnis sehen soll!
    runswing(newfiledialog.jFileChooser1.setCurrentDirectory(filetest)  ) 
    # FileCjooserDialog aufrufen
    returnVal = newfiledialog.jFileChooser1.showOpenDialog(newfiledialog)
    #print "file returnVal:", returnVal
    
    if (returnVal == JFileChooser.APPROVE_OPTION): # nur wahr, wenn Datei ausgew?hlt wurde
        # KEIN Abbruch
        datei = str(newfiledialog.jFileChooser1.getSelectedFile())
        filename = datei.split("/").pop() # den Pfad aufspalten in eine Liste mit Elementen getrennt von /
        
        # und fahre mit dem Verarbeiten fort
        currentdir = newfiledialog.jFileChooser1.getCurrentDirectory() 
        
        bitmuster = textDateiEinlesen(datei,filename)
        #print "return einlesen:", bitmuster
        if bitmuster != -1: # nur wenn die eingelesene Datei gültig ist
            korrekt = initPicture(bitmuster)
            if korrekt != -1:
                # schon vorhandene Hinweise ?bernehmen
                hinweis = jframeActionButtons.jTextFieldStatusBar.getText()
                hinweis = hinweis+"\n"+"Datei  "+filename+"  eingelesen"
                # in Abh?ngigkeit der vorherigen Hintergrundfarbe
                # wird die textfarbe gesetzt - historische Gr?nde
                #print ( jframeActionButtons.jTextFieldStatusBar.getBackground() )
                if (jframeActionButtons.jTextFieldStatusBar.getBackground() == Color.ORANGE):
                
                    jframeActionButtons.jTextFieldStatusBar.setForeground( Color.ORANGE)
                    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
                else:
                    jframeActionButtons.jTextFieldStatusBar.setForeground( MYGREEN)
                    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
                    
                jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
     # end if
     
    # sonst mach nix (bei abbrechne) 
    # speichere aber den aktuellen Pfad
    currentdir = newfiledialog.jFileChooser1.getCurrentDirectory()
    
    # und den aktuellen Speicher anzeigen
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    runswing(initPicture(bitmuster))
    runswing(getPicture2())  
       
   
#-------------- SPEICHERN Dialog ------------
def textDateiSpeichernOnKlick(event):
    
    bitmuster = getPicture() # Bild als bitmuster erstellen
    
    # und als Datei schreiben
    
    # Dialog auf Speichern setzen
    newfilesavedialog.jFileChooser2.setDialogType(JFileChooser.SAVE_DIALOG)
    # gibt Fehler bei .jar aus
    #dir_path = os.path.dirname(os.path.realpath(__file__))
    # funktioniert ebenfalls unter jar nicht
    #dir_path = java.lang.System.getProperty("user.home")
    # according to
    # https://stackoverflow.com/questions/16771894/python-nameerror-global-name-file-is-not-defined
    # this is the best solution!
    dir_path = os.getcwd()
    
    #print dir_path
    #print os.getcwd()
    # dies ist notwendig, um den Path als String in ein jav.io.File Objekct zu casten!
    filetest = File(dir_path)
    # um diesen dann im FileChooser weiter zu verwenden
    # Hintergrund ist, dass der User immer nur das aktuelle Arbeitsverzeichnis sehen soll!
    newfilesavedialog.jFileChooser2.setCurrentDirectory(filetest)    
    # FileCjooserDialog aufrufen
    #newfilesavedialog.jFileChooser1.showOpenDialog(newfilesavedialog)
    
    # die txt Erweiterung vorbereiten
    #extension = FileNameExtensionFilter("TEXT FILES", "txt", "text")
    #newfilesavedialog.jFileChooser2.setFileFilter(extension)
    #newfilesavedialog.jFileChooser2.addChoosableFileFilter(extension)
    returnVal = newfilesavedialog.setVisible(True)
    # returnVal ist nicht verl??sslich in diesem SAVE Dialog - warum nicht?
    # deshalb ?ber den Dateinamen
    datei = str(newfilesavedialog.jFileChooser2.getSelectedFile());
    filename = datei.split("/").pop() # den Pfad aufspalten in eine Liste mit Elementen getrennt von /
         
    if (datei != "None"): # nur wahr, wenn Datei ausgew?hlt wurde
        # KEIN Abbruch
        datei = str(newfilesavedialog.jFileChooser2.getSelectedFile());
        dateiName = datei
        textDateiSchreiben(dateiName, filename)
    # sonst wurde Abrechen gew?hlt, also mache nix
    # end if

#-------------- ANALYSE Dialog ------------
def textDateiAnalyseOnKlick(event):
    #messageDialog.setVisible(True)
    # Dialog auf ?ffnen setzen
    newfiledialog.jFileChooser1.dialogType=JFileChooser.OPEN_DIALOG
    
    newfiledialog.jFileChooser1.setDialogTitle("Datei zum Analysieren auswaehlen")
    
    #dir_path = os.path.dirname(os.path.realpath(__file__))
    dir_path = os.getcwd()
    # dies ist notwendig, um den Path als String in ein jav.io.File Objekct zu casten!
    filetest = File(dir_path)
    # um diesen dann im FileChooser weiter zu verwenden
    # Hintergrund ist, dass der User immer nur das aktuelle Arbeitsverzeichnis sehen soll!
    newfiledialog.jFileChooser1.setCurrentDirectory(filetest)    
    # FileCjooserDialog aufrufen
    returnVal = newfiledialog.jFileChooser1.showOpenDialog(newfiledialog)
    #print "file returnVal:", returnVal
    
    if (returnVal == JFileChooser.APPROVE_OPTION): # nur wahr, wenn Datei ausgew?hlt wurde
        # KEIN Abbruch
        datei = str(newfiledialog.jFileChooser1.getSelectedFile())
        filename = datei.split("/").pop() # den Pfad aufspalten in eine Liste mit Elementen getrennt von /
        
        # und fahre mit dem Verarbeiten fort
        currentdir = newfiledialog.jFileChooser1.getCurrentDirectory() 
        
        hinweis = textDateiAnalyse(datei,filename)
        
        messageDialog.setTitle("Analyse der Datei")
        messageDialog.jTextArea1.setText(hinweis)
        messageDialog.setVisible(True)   
    
        #print "return einlesen:", bitmuster
        
     # end if
     
    # SONST mach nix (bei abbrechne) 
    # speichere aber den aktuellen Pfad
    currentdir = newfiledialog.jFileChooser1.getCurrentDirectory() 
    return

#--------------        
#def getPictureOnKlick(event): # ALZ?? kann weg?? bitstream ausgeben
#    
#    bitstream = picture2bitstream()
#    textarea.setText(bitstream)


# *********** Menu OPERATIONEN auf Speicher
def speicherLoeschenOnKlick(event):
    # INITIALISIERE SPeicher mit Nullen
    bitstream = (wert2bitstream(0)) # test mit der runnable Funktion
    runswing(bitstream2picture(bitstream)) # s.o.
    runswing(getPicture2())


def speicherFuellenOnKlick(event):
    # INITIALISIERE SPeicher mit Einsen
    bitstream = (wert2bitstream(1)) # test mit der runnable Funktion
    runswing(bitstream2picture(bitstream)) # s.o.
    runswing(getPicture2())


def speicherZufallsFuellenOnKlick(event):
    # erzeuge einen Zufalls-Bitstream
    bitstream = zufall2bitstream()
    # und ?bertrage diesen in das Bild
    runswing(bitstream2picture(bitstream)) # s.o.
    # und dann in den Speicher
    runswing(getPicture2())


def speicherInvertOnKlick(event):
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    bitstream = "" # den bitstream-String initialisieren
    for zeilenElement in bitmuster: # die Liste elementweise durchlaufen
        bitstream = bitstream + zeilenElement
    # end for
    invertbitstream = "" # den invertBitsream vorbereiten
    # bitstream bit-weise durchlaufen
    for bit in bitstream:
        if bit == "1":
            invertbitstream= invertbitstream + "0"
        if bit == "0":
            invertbitstream = invertbitstream + "1"
        if bit!="1" or bit!="0":
            pass
            hinweis = "Fehler! Der Bitstream enth?lt ung?ltige Zeichen"
    # end for
    #print "invert:"
    #print invertbitstream
    
    runswing(bitstream2picture(invertbitstream))
    runswing(getPicture2())     
            

def speicherRotateLeftOnKlick(event):
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    shiftbitstream = bitstreamOperation(bitmuster, "RL")
    runswing(initPicture(shiftbitstream))
    runswing(getPicture2())  
    

def speicherRotateRightOnKlick(event):
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile

    #shiftbitstream = bitstreamShiftRight(bitmuster)
    shiftbitstream = bitstreamOperation(bitmuster, "RR")
    runswing(initPicture(shiftbitstream))
    runswing(getPicture2())  

def speicherShiftLeftOnKlick(event):
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    #shiftbitstream = bitstreamShiftLeft(bitmuster)
    shiftbitstream = bitstreamOperation(bitmuster, "SL")
    runswing(initPicture(shiftbitstream))
    runswing(getPicture2())  
    

def speicherShiftRightOnKlick(event):
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    shiftbitstream = bitstreamOperation(bitmuster, "SR")
    runswing(initPicture(shiftbitstream))
    runswing(getPicture2())  

    
# *********** INTERNE Funktionen *********

# SHIFT und ROTATE Operationen auf dem Speicher
def bitstreamOperation(bitstream, modus): #shifted die in dem bitstream enthaltenen bitmuster um eine Stelle nach Angabe von modus
# modus = SL, SR, RL, RR als String SL=ShiftLeft, RR=RotateRight, respektive       
    shiftbitstream = [] # Initialiserung des Ausgabe-Bitstream
    
    # shift LEFT
    if modus == "SL":
        for zeile in range(0,ZEILEN_KONST): # Zeilen (Bitmuster Index) durchlaufen
            bitmuster = bitstream[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
            # nur die ersten n-1 zeichen vesschieben
            shiftbitmuster = ""
            for spalte in range(1,SPALTEN_KONST): # Spalte von links durclaufeb HINWEIS: endwert wird bei iteration immer ausgelassen!!           
                if bitmuster[spalte] =="1":
                    shiftbitmuster = shiftbitmuster + "1"
                else:
                   shiftbitmuster = shiftbitmuster + "0"
                   
            # end for spalte
            #das letzte Zeichen ist eine 0
            shiftbitmuster = shiftbitmuster + "0"
            #print shiftbitmuster
            shiftbitstream.append(shiftbitmuster)
        
    # shift RIGHT
    if modus == "SR":
        for zeile in range(0,ZEILEN_KONST): # Zeilen (Bitmuster Index) durchlaufen
        
            bitmuster = bitstream[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
            #print bitmuster
            # nur die ersten n-1 zeichen verschieben
            shiftbitmuster = ""
            shiftbitmuster = shiftbitmuster + "0" # bei einem rechts Shift wird zuerst von links die 0 eingeschoben
            for spalte in range(0,SPALTEN_KONST-1): # Spalte von links durclaufeb HINWEIS: endwert wird bei iteration immer ausgelassen!!
                if bitmuster[spalte] =="1":
                    shiftbitmuster = shiftbitmuster + "1"
                else:
                   shiftbitmuster = shiftbitmuster + "0"
                   
            # end for spalte
            
            shiftbitstream.append(shiftbitmuster)
        # end for zeile
    # end if
        
    # ROTATE right
    if modus == "RR":
        for zeile in range(0,ZEILEN_KONST): # Zeilen (Bitmuster Index) durchlaufen
        
            bitmuster = bitstream[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
            #print bitmuster
            # nur die ersten n-1 zeichen verschieben
            shiftbitmuster = ""
            
            # merken des rechten Bit
            rightmostbit = bitmuster[SPALTEN_KONST-1]
            shiftbitmuster = shiftbitmuster + rightmostbit # bei einem rechts Shift wird zuerst von links das rmb eingeschoben
            #weiter so verfahren wie shift right
            for spalte in range(0,SPALTEN_KONST-1): # Spalte von links durclaufeb HINWEIS: endwert wird bei iteration immer ausgelassen!!
                if bitmuster[spalte] =="1":
                    shiftbitmuster = shiftbitmuster + "1"
                else:
                   shiftbitmuster = shiftbitmuster + "0"
                   
            # end for spalte
            
            shiftbitstream.append(shiftbitmuster)
        # end for zeile
    # end if
    
    # shift LEFT
    if modus == "RL":
        for zeile in range(0,ZEILEN_KONST): # Zeilen (Bitmuster Index) durchlaufen
            bitmuster = bitstream[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
            
            # merken des linken bit
            leftmostbit = bitmuster[0]
            shiftbitmuster = ""
            # die weiteren  n-1 bit verschieben
            for spalte in range(1,SPALTEN_KONST): # Spalte von links durchlaufen HINWEIS: endwert wird bei iteration immer ausgelassen!!           
                if bitmuster[spalte] =="1":
                    shiftbitmuster = shiftbitmuster + "1"
                else:
                   shiftbitmuster = shiftbitmuster + "0"
                   
            # end for spalte
            # das letzte Zeichen ist unser gemerktes lmb
            shiftbitmuster = shiftbitmuster + leftmostbit
            #print shiftbitmuster
            shiftbitstream.append(shiftbitmuster)
              
    return shiftbitstream


def initPicture(bitmuster): # Lädt eine Liste von bitmuster = EIN(!) bitstream, spaltet diese in einzelne Bitmuster auf und lädt diese in mygrid (picture) zur Darstellung
    
    hinweis=""
    #print (bitmuster)
    
    for zeile in range(0,len(bitmuster)): # Zeile bug? 19.9.23 ZEILEN_KONST durch len(bitmuster) ersetzt - funzt
        #print (zeile)
        aktuell = bitmuster[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
       
        for spalte in range(SPALTEN_KONST-1,-1,-1): # Spalte HINWEIS: endwert wird bei iteration immer ausgelassen!!
            
            loc = Location(spalte, zeile) # GameGrid Koordinaten beginnen bei (0,0) !!
            
            # auf gültiges Zeichen prüfen           
            if aktuell[spalte]!="0" and aktuell[spalte]!="1":
                hinweis="HINWEIS: Unerlaubtes Zeichen "+str(aktuell[spalte])+" in der "+str(zeile)+". Zeile der Datei!"
                jframeActionButtons.jTextFieldStatusBar.setForeground( Color.RED)
                jframeActionButtons.jTextFieldStatusBar.setBackground(Color.ORANGE)
                jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                return -1 # mit fehlercode zur?ck
                #print aktuell[spalte]
                #print "HINWEIS: Unerlaubtes Zeichen "+str(aktuell[spalte])+" in der "+str(zeile)+". Zeile der Datei!" # aber nur Hinweis ausgeben
            # trotzdem immer darstellen
            if aktuell[spalte] =="1":
                runswing(bg.fillCell(loc,Color.black))
            else:
               runswing(bg.fillCell(loc,Color.white) )
    #end for zeile
    if hinweis !="":
        pass
        #print hinweis
        
    # notwendig?
    runswing(zeilengrid.refresh())
    runswing(dateigrid.refresh())
    runswing(mygrid.refresh())
    runswing(newJframe.repaint())
    return 0   
  
#-------------
def picture2bitstream(): # gibt das aktuelle Bild (mygrid) als Bitstream aus
    
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    bitstream = "" # den bitstream-String initialisieren
    for zeilenElement in bitmuster: # die Liste elementweise durchlaufen
        bitstream = bitstream + zeilenElement
    # end for
    return bitstream

#----------  ALT L?SCHBAR??  
#def setPictureOnKlick(event):   #bitstream einlesen
#    
#    bitstream = textarea.getText()
#    runswing(bitstream2picture(bitstream))
#    

#-------------
def bitstream2picture(bitstream): # wandelt den übergebenen Bitstream in das aktuelle Bild (mygrid)
    global showBitstream # True, wenn Checkbox Bitstream anzeigen geklickt
    
    hinweis=""
    
    if len(bitstream)==(SPALTEN_KONST*ZEILEN_KONST): # dann ist alles gut und es kann weiter gehen
        bitmuster = []
        
        for element in range(0, len(bitstream), SPALTEN_KONST):
            zeile =(bitstream[element:element+SPALTEN_KONST]) # bitstream in zeilen aufteilen
            bitmuster.append(zeile)
            
        # end for
        
        runswing(initPicture(bitmuster))
        
        hinweis_alt = jframeActionButtons.jTextFieldStatusBar.getText() 
        #print(hinweis_alt)
        if showBitstream: # nur wenn bitsream anzeige angeklickt
        
            hinweis="Bitstream erfolgreich importiert!"
            hinweis = String(hinweis,"utf-8")
            jframeActionButtons.jTextFieldStatusBar.setForeground( Color.GREEN)
            jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
            jframeActionButtons.jTextFieldStatusBar.setText(hinweis) 
                 
#        hinweis="Bitstream erfolgreich in den Speicher uebertragen."
#        # weisser TExt auf gr?n
#        #jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE )
#        #jframeActionButtons.jTextFieldStatusBar.setBackground(MYGREEN)
#        # gr?ner Text auf weiss
#        jframeActionButtons.jTextFieldStatusBar.setForeground( MYGREEN)
#        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
#        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
        #print hinweis
      
    else:
        hinweis="Bitstream hat eine falsche Länge!"
        hinweis = String(hinweis,"utf-8")
        jframeActionButtons.jTextFieldStatusBar.setForeground( Color.RED)
        jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
        jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                    
#        aktuell = bitmuster[zeile] # erste Zeile der Liste bitmuster in aktuell speichern
#       
#        for aktspalte in range(spalten-1,-1,-1): # Spalte HINWEIS: endwert wird bei iteration immer ausgelassen!!
#            loc = Location(spalte, aktzeile) # GameGrid Koordinaten beginnen bei (0,0) !!
#            
#            # auf g?ltiges Zeichen pr?fen           
#            if aktuell[aktspalte]!="0" and aktuell[aktspalte]!="1":
#                #print aktuell[spalte]
#                print "HINWEIS: Unerlaubtes Zeichen "+str(aktuell[aktspalte])+" in der "+str(aktzeile)+". Zeile der Datei!" # aber nur Hinweis ausgeben
#            # trotzdem immer darstellen
#            if aktuell[aktspalte] =="1":
#                bg.fillCell(loc,farbe)
#    #end for zeile
#    if hinweis !="":
#        print hinweis

#---------ALT L?SCHBAR?
#def zeileOnKlick(event):
#    
#    zeilennummer=int(zeilenfeld.getText())
#    #zeilennummer = input("Eingabe der Zeilennummer (Beginn bei 1!):")
#    ausgabestring = zeile2bitmuster(zeilennummer)
#    #print ausgabestring
#    ausgabeBereich.setForeground(Color.BLACK)
#    ausgabeBereich.setText(ausgabestring)

    
# ------  BITSTREAMS Menu    
# ----------------
def bitstreamDateiEinlesenOnKlick(event):
    
    global bitstreamS # diese Liste von Bitstreams wird ?bergreifend genutzt
    # Dialog auf ?ffnen setzen
    newfiledialog.jFileChooser1.dialogType=JFileChooser.OPEN_DIALOG
    
    #dir_path = os.path.dirname(os.path.realpath(__file__))
    
    dir_path = os.getcwd()
    # dies ist notwendig, um den Path als String in ein jav.io.File Objekct zu casten!
    filetest = File(dir_path)
    # um diesen dann im FileChooser weiter zu verwenden
    # Hintergrund ist, dass der User immer nur das aktuelle Arbeitsverzeichnis sehen soll!
    runswing(newfiledialog.jFileChooser1.setCurrentDirectory(filetest)  ) 
    # FileCjooserDialog aufrufen
    returnVal = newfiledialog.jFileChooser1.showOpenDialog(newfiledialog)
    #print "file returnVal:", returnVal
    
    if (returnVal == JFileChooser.APPROVE_OPTION): # nur wahr, wenn Datei ausgew?hlt wurde
        # KEIN Abbruch
        datei = str(newfiledialog.jFileChooser1.getSelectedFile())
        filename = datei.split("/").pop() # den Pfad aufspalten in eine Liste mit Elementen getrennt von /
        
        # und fahre mit dem Verarbeiten fort
        currentdir = newfiledialog.jFileChooser1.getCurrentDirectory() 
        # in bitstreamS stehen jetzt alle bitstreams der Datei drin!
        bitstreamS = bitstreamSDateiEinlesen(datei, filename)
        #print(bitstreamS)
        
        if bitstreamS != -1:
            
            #runswing((initPicture(bitstreamS)))
            #korrekt = (initPicture(bitstreamS))
            korrekt = bitstream2picture(bitstreamS)
            #print (bitstreamS[0])
            bitstream2picture(bitstreamS[0]) # der ERSTE Bitstream wird in den Speicher geladen und angezeigt
           
            #print (korrekt)
            if korrekt != -1:
                
                fensterTitelBitstreams = "Bitstreams-Datei eingelesen: "+str(len(bitstreamS))+" Bitstreams in der Datei mit je "+str(SPALTEN_KONST)+" bit Datenbreite"
            
                newJframe.setTitle(fensterTitelBitstreams)
                
                hinweis="Bitstreams-Datei \n"+filename+" \neingelesen: \n"+str(len(bitstreamS))+" Bitstreams in der Datei mit je "+str(SPALTEN_KONST)+" bit Datenbreite.\nDer erste Bitstream (von "+str(len(bitstreamS))+") ist in den Speicher geladen und wird jetzt angezeigt."
                jframeActionButtons.jTextFieldStatusBar.setForeground( MYGREEN)
                jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
                jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                
                # und die Menupunkte frei schalten
                newJframe.jMenuBitstreamSpeicherAnhaengen.setEnabled(True)
                newJframe.jMenuBitstreamDateiPlay.setEnabled(True)
                newJframe.jCheckBoxMenuBitstreamsRepeat.setEnabled(True)
                newJframe.jCheckBoxMenuBitstreamsRepeat5.setEnabled(True)
                newJframe.jRadioButtonBitstream005Sekunden.setEnabled(True)
                newJframe.jRadioButtonBitstream01Sekunden.setEnabled(True)
                newJframe.jRadioButtonBitstream02Sekunden.setEnabled(True)
                newJframe.jRadioButtonBitstream05Sekunden.setEnabled(True)
            else: # es ist ein Fehler aufgetreten!
                hinweis="Es ist ein Fehler beim Einlesen der Bitstreams-Datei aufgetreten."
                jframeActionButtons.jTextFieldStatusBar.setForeground( MYRED)
                jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
                jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    
        
        # end if
    
    # sonst mach nix (bei abbrechne) 
    # speichere aber den aktuellen Pfad
    currentdir = newfiledialog.jFileChooser1.getCurrentDirectory()
    
    # und den aktuellen Speicher anzeigen
    bitmuster = getPicture() # hole das Bild als Liste von Bitmuster pro Zeile
    #print(bitmuster)
    runswing(initPicture(bitmuster))
    runswing(getPicture2())  
       
# end def

def bitstreamSpeicherAnhaengenOnKlick(event):
    pass # to do

# spielt die BitstreamS ab ----------
def bitstreamDateiPlayOnKlick(event):
    
    # Wiederholungen ausgewählt?
    wiederholt3 = int(newJframe.jCheckBoxMenuBitstreamsRepeat.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    wiederholt5 = int(newJframe.jCheckBoxMenuBitstreamsRepeat5.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    
    if wiederholt3 + wiederholt5 == 2: # wenn beide ausgewählt sind, dann easter egg mit 8 mal Wiederholung
        wiederholungsanzahl = 8 # hier noch hardcodiert, laut Menueintrag
    elif wiederholt5 == 1: # wenn die WiederhlungsCheckbox für 5 aktiviert ist
        wiederholungsanzahl = 5 # hier noch hardcodiert, laut Menueintrag
    elif wiederholt3 == 1: # wenn die WiederhlungsCheckbox für 3 aktiviert ist
        wiederholungsanzahl = 3 # hier noch hardcodiert, laut Menueintrag
        
    else: # wenn nichts ausgewählt ist, dann nur eine Wiederholung
        wiederholungsanzahl = 1 # sonst nur einmaliger Durchlauf
    
    # welche Anzeigendauer ist ausgewählt?  noch hardcodiert
    if int(newJframe.jRadioButtonBitstream005Sekunden.selected): # wird 1, wenn Checkbox aktiviert, 0 sonst
        BITSTREAM_ANZEIGE_DELAY = 0.05
    if int(newJframe.jRadioButtonBitstream01Sekunden.selected): # wird 1, wenn Checkbox aktiviert, 0 sonst
        BITSTREAM_ANZEIGE_DELAY = 0.1
    if int(newJframe.jRadioButtonBitstream02Sekunden.selected): # wird 1, wenn Checkbox aktiviert, 0 sonst
        BITSTREAM_ANZEIGE_DELAY = 0.2
    if int(newJframe.jRadioButtonBitstream05Sekunden.selected): # wird 1, wenn Checkbox aktiviert, 0 sonst
        BITSTREAM_ANZEIGE_DELAY = 0.5
        
    anzahlBitstreams = 0
    #offset = 0.3
    startzeit = time.time()
    for durchlauf in range(0,wiederholungsanzahl): 
        for bitstream in bitstreamS:
            anzahlBitstreams = anzahlBitstreams + 1
            #Timer(offset*anzahlBitstreams, bitstream2picture(bitstream), ()).start()
            runswing(bitstream2picture(bitstream))           
            #refresh()
            #seconds = 0.1
            #BITSTREAM_ANZEIGE_DELAY
            runswing(time.sleep(BITSTREAM_ANZEIGE_DELAY))  # sleep while time-delay events execute(BITSTREAM_ANZEIGE_DELAY) # Verz?gert die Anzeige 
            runswing(getPicture2())
        # end for bitsream
    # end for durchlauf
        
    endzeit = time.time()
    gesamtzeit = endzeit - startzeit
    gesamtzeit = round(gesamtzeit,1)
    hinweis="Die Anzeige von "+str(anzahlBitstreams)+" Bitstreams (Speicherinhalten) erfolgte in "+str(gesamtzeit)+" Sekunden.\nDer erste Bitstream (von "+str(len(bitstreamS))+") ist in den Speicher geladen und wird jetzt angezeigt."
    jframeActionButtons.jTextFieldStatusBar.setForeground( Color.BLACK)
    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    
    # zum Abschluss wieder den ersten Bitstream anzeigen
    bitstream2picture(bitstreamS[0]) # der ERSTE Bitstream wird in den Speicher geladen und angezeigt 

      
# --------------------------- TASTENfunktionen  -------------------

def zeile2bitmuster(zeilennummer):
    ausgabestring=""
    if zeilennummer <= zeilen or zeilennummer>0:
        bitmuster = getZeile(zeilennummer) # Zeile als bitmuster erstellen
       
        (dualzahlstring,ergebnisstring,ergebnis)=bitmuster2dual(bitmuster)
        
    else: 
        pass
        #print("FEHLER: Zeilennummer zu gross oder zu klein!")
    
    ausgabestring= ausgabestring+"Inhalt der Speicheradresse "+str(zeilennummer) + " als Bitmuster: "
    for element in bitmuster:
            ausgabestring= ausgabestring+element
    ausgabestring= ausgabestring + "\nInterpretation als Dualzahl:\n(^ steht fuer die Potenzierung, * fuer das Multiplikationszeichen)"
    ausgabestring += "\n= "+ dualzahlstring
    ausgabestring += "\n= "+ ergebnisstring
    ausgabestring += "\n= "+ str(ergebnis)+ " (Dezimal)"
    ausgabestring += "\n= "+ format(ergebnis, "X")+ " (HEXadezimal)"

    return ausgabestring


def getPicture(): # gibt das aktuelle Bild als Liste von bitmustern, zeilenweise getrennt, in mygrid aus und dann zur?ck
    
    bitmuster=[] # Bitmuster als Liste
    for zeile in range(0,zeilen): # Zeile
        zeilenstring=""
        for spalte in range(spalten-1,-1,-1): #  spaltenweise auslesen von links nach rechts, 
            loc = Location(spalte, zeile)
            zellfarbe= bg.getColor(loc)
            if zellfarbe == Color.black:
                zeilenstring= "1"+zeilenstring
            else:
                zeilenstring=  "0"+zeilenstring
            
        bitmuster.append(zeilenstring) # hier lokale Definition, deshalb kein Namenskonflikt!
    #end for zeile
    return bitmuster
# end def 


def getPicture2(): # WICHTIG: ?bertr?gt aus mygrid die Daten in das aktuelle DATEIGRID. Gibt das aktuelle Bild als Liste von bitmustern, zeilenweise getrennt, zur?ck
    
    #bitmuster=[] # Bitmuster als Liste
    for zeile in range(0,zeilen): # Zeile
        zeilenstring=""
        for spalte in range(spalten-1,-1,-1): #  spaltenweise auslesen von links nach rechts, 
            loc = Location(spalte, zeile)
            zellfarbe= bg.getColor(loc) # Zellfarbe der aktuellen Bildstelle holen
            loc2 = Location(spalte,zeile)
            loc2point = dateigrid.toPoint(Location(spalte,zeile))
            loc2point.translate(-7,5) # Offset zur besseren Platzierung in der Mitte der Gridzelle
            #dateifont = Font("SansSerif",Font.PLAIN,11) # jetzt als KONSTANTE festgelegt
            bgdatei.setFont(DATEIFONT)
            if zellfarbe == Color.black:
                bgdatei.fillCell(loc2,dateigridColor) # wichtig, sonst wird der INhalt nicht neu dargstellt, sondern immer ?berlagert!
                bgdatei.drawText("1", loc2point)
            else:
                bgdatei.fillCell(loc2,dateigridColor)
                bgdatei.drawText("0", loc2point)
                        
            #bgdatei.fillCell(loc2,Color.white)
                        
        #bitmuster.append(zeilenstring) # hier lokale Definition, deshalb kein Namenskonflikt!
    #end for zeile
    dateigrid.refresh()
    #dateigrid.repaint()
    #return bitmuster
    
    # Kopie in die Zwischenablage?    
    if int(newJframe.jCheckBoxSpeicherCopy.selected): # wird 1, wenn Checkbox aktiviert, 0 sonst
        clipboard.setContents(StringSelection(picture2bitstream()), None)
        
    # Aktualisierung des Bitstream im Bitstream-Fenster    
    if showBitstream:       
            bitstreamfield = picture2bitstream()       
            jframebitstream.jTextBitstream.setText(bitstreamfield)
# end def 


def fillZeilenGrid(zeilengrid): # f?hrt auf dem aktuellen Zeilengrid die aktion aus. gibt das aktuelle Bild als Liste von bitmustern, zeilenweise getrennt, aus
    #bitmuster=[] # Bitmuster als Liste
    for zeile in range(0,zeilen): # Zeile
        if zeile <10:
            zeilenstring=" "+str(zeile)
        else:
            zeilenstring=str(zeile)
        spalte=0 # es gibt nur eine Spalte...
        loc2 = Location(spalte,zeile)
        loc2point = zeilengrid.toPoint(Location(spalte,zeile))
        loc2point.translate(-7,5) # Offset zur besseren Platzierung in der Mitte der Gridzelle: (x,y)
        #bgzeile.fillCell(loc2,Color.white)
        
        bgzeile.setFont(ZEILENFONT)
        bgzeile.drawText(str(zeilenstring), loc2point)
# end def 


def getZeile(zeilennummer): # 
    
    bitmuster=[] # Bitmuster als Liste
    zeile = zeilennummer # Zeile
    zeilenstring=""
    # HINWEIS: endwert (hier -1) wird bei iteration immer ausgelassen!!, deshalb Ende bei 0
    for spalte in range(spalten-1,-1,-1): # spaltenweise auslesen von links nach rechts, 
        loc = Location(spalte, zeile)
        zellfarbe= bg.getColor(loc)
        if zellfarbe == Color.black:
            zeilenstring= "1"+zeilenstring # String von links nach rechts aufbauen
        else:
            zeilenstring= "0"+zeilenstring
        
    bitmuster.append(zeilenstring) # hier lokale Definition, deshalb kein Namenskonflikt!
    #end for zeile
    return bitmuster
# end def 


def bitmuster2dual(bitmuster): # konvertiert ein (mehrstelliges) Bitmuster (Zeichenkette!) in eine Dualzahl und gibt den Dezimalwert aus
    #print len(bitmuster[0])
    laenge = len(bitmuster[0])
    musterRev = bitmuster[0][::-1] # muster reverse zum besseren Durchlaufen
    dualzahlstring =""
    ergebnisstring  = ""
    ergebnis = 0
    for stelle in range(laenge-1,-1,-1):
        if dualzahlstring!="":
            dualzahlstring=dualzahlstring+"+"
        if ergebnisstring!="":
            ergebnisstring=ergebnisstring+"+"
        #print stelle
        #print musterRev[stelle]
        dualzahlstring = dualzahlstring + "(2^"+str(stelle)+" * "+musterRev[stelle]+ ")"
        #print dualzahlstring
        zwischenergebnis=(2**(stelle))*int(musterRev[stelle])
        ergebnisstring = ergebnisstring + str(zwischenergebnis)
        #print ergebnisstring
        ergebnis = ergebnis + ( (2**(stelle))*int(musterRev[stelle]) )
    # R?ckgabe von mehrerern R?ckgabeparamteren per Tupel    
    return(dualzahlstring,ergebnisstring,ergebnis) # R?ckgabe der Dualzahlwertigkeiten pro Stelle, der Ergebnisterme und des Gesamtergebnisses (Dezimal)

#----------- Lese den Bitstream aus dem Bitstream-Fenster ein
def bitstreamEinlesenOnKlick(event):
    
    bitstreamfield=jframebitstream.jTextBitstream.getText() # bitstream aus dem testfeld holen
    runswing(bitstream2picture(bitstreamfield))
    #print bitstreamfield
    runswing(getPicture2()) # WICHTIG, denn hier werden aus mygrid die Daten in dateigrid ?bertragen!

        
#----------- Kopiere den Bitstream aus dem Bitstream-Fenster in die Zwischenablage
def bitstreamCopyOnKlick(event):
    
    bitstreamfield=jframebitstream.jTextBitstream.getText() # bitstream aus dem Textfeld holen
    clipboard.setContents(StringSelection(bitstreamfield), None)
    #bitstream2picture(bitstreamfield)
    #print bitstreamfield
    #runswing(getPicture2()) # WICHTIG, denn hier werden aus mygrid die Daten in dateigrid ?bertragen!
   
 
def bitstreamFromClipboardOnKlick(event):
    
    # https://stackoverflow.com/questions/3591945/copying-to-the-clipboard-in-java
    # clipboardReferenz ist ein Transferable Objekt aus Clipboard
    clipboardReferenz = clipboard.getContents(None) # der Parameter ist laut API vorgegeben, wird aber nicht benutzt
    # der INhalt wird aus der Refenz geholt
    clipboardContens = clipboardReferenz.getTransferData( DataFlavor.stringFlavor )
    jframebitstream.jTextBitstream.setText(clipboardContens)

   
#----------- Erstelle zuf?lligen Bitstream, erzeugt einen Zufallsbitstream und gib diesen im Bitstreasm-Fenster aus
def bitstreamZufallOnKlick(event):
    
    bitstream = zufall2bitstream()

    jframebitstream.jTextBitstream.setText(bitstream)
    #textarea.setText(bitstream)
    hinweis = "Zufaelliger Bitstream erfolgreich erzeugt und in den Bitstream-Bereich geladen."
    jframeActionButtons.jTextFieldStatusBar.setForeground( MYGREEN)
    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
                    
    
    #bitstreamfield=jframebitstream.jTextBitstream.getText() # bitsteram aus dem testfeld holen
    #bitstream2picture(bitstreamfield)
    
# ------ ZEILE ausgeben on BUTTON-klick
def zeileAusgebenOnKlick(event):
    
    # die Zeilennummer aus dem Button-Fenster holen
    zeilennummer = jframeActionButtons.jComboBox1.getSelectedIndex()
    # den hinweis-String basteln
    hinweis = zeile2bitmuster(zeilennummer)
    # Ausgabe in das Nachrichtenfeld
    jframeActionButtons.jTextFieldStatusBar.setForeground(Color.BLACK)
    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.WHITE)
    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    

# ------------------------------------  BITSTREAM Fenster ----------------------------------------
def showBitStreamOnKlick(event): # BITStREAM Button Event
        # toggle Flag
        global showBitstream # muss leider global sein
        global jframebitstreamlocation # wieder getrickst
        global jframebitstreamsize # s.o.
        
        #print "frame size:",newJframe.getSize()
        # boolsche Variable, die angibt, ob das BitstreamFenster sichtbar
        showBitstream = not(showBitstream)
        
        if showBitstream:
            
            # die Button sichtbar machen
            jframeActionButtons.jButtonBitstreamEinlesen.setEnabled(True)
            jframeActionButtons.jButtonBitstreamCopy.setEnabled(True)
            jframeActionButtons.jButtonBitstreamFromClipboard.setEnabled(True)
        
            bitstreamfield = picture2bitstream()
           
            frameX =newJframe.getX()
            frameY =newJframe.getY()
            frameWidth = newJframe.getWidth()
            frameHeight = newJframe.getHeight()
            
            frameWidthButtonWindow = jframeActionButtons.getWidth()
            
            
            
            # ?berpr?fen, ob eine Location f?r den Fenster schon vorliegt
            if jframebitstreamlocation:
                jframebitstream.setLocation(jframebitstreamlocation) # wenn ja, dann benutze diese
                
            else:
                # wenn nicht (leer), dann positionere das Fenster unter das Hauptfenster 
                jframebitstream.setLocation(frameX, frameY+frameHeight) 
                   
            #jframebitstream.setSize(frameWidth,100)
            #jframebitstream.jTextBitstream.setSize(frameWidth, 100)
            jframebitstream.jTextBitstream.setText(bitstreamfield)
            offset = 60 # offset f?r die Fensterborderh?he: ungef?hrer Wert, verindert die Anzeige der scrollbars
            #prefSize = jframebitstream.jTextBitstream.getPreferredSize() # gibt die bevorzugte Gr??e f?r das jetzt mit Text gef?llte Feld
            #print "1a",prefSize
            #print "1b",jframebitstream.getSize()
            #jframebitstream.jTextBitstream.setSize(prefSize) # setze auf die gew?nschte Gr?sse damit wir keine ScrollBars mehr haben
            labelbitstreamtext = "Laenge des Bitstreams: "+str(len(bitstreamfield))+ " Erforderliche Laenge: "+str(bitstreamlaenge)
            jframebitstream.jLabelBitstream.setText(labelbitstreamtext)
            #jframebitstream.revalidate()
            #jframebitstream.pack()
            
            if jframebitstreamsize:
#                print "2a",jframebitstreamsize
                jframebitstream.setSize(jframebitstreamsize)
                
            else: # bei der ersten Anzeige initialisiere das Frame
                 jframebitstream.jScrollPane1.setSize(frameWidth, 100)
                 jframebitstream.setSize(frameWidth, 100) # Anfangsgr?sse auf Standard setzen
                 #prefSize = jframebitstream.jTextBitstream.getPreferredSize() # gibt die bevorzugte Gr??e f?r das jetzt mit Text gef?llte Feld
                 jframebitstream.jTextBitstream.setSize(frameWidth,100)
                 jframebitstream.jTextBitstream.setText(bitstreamfield)
                 #jframebitstream.jTextBitstream.setCaretPosition(jframebitstream.jTextBitstream.getDocument().getLength());
                 jframebitstream.jTextBitstream.revalidate()
                 jframebitstream.jScrollPane1.revalidate()
#                 print "3", jframebitstream.jTextBitstream.getDocument().getLength()
#                 print "3-",jframebitstream.jTextBitstream.modelToView(jframebitstream.jTextBitstream.getDocument().getLength())
                 prefSizeTextArea = jframebitstream.jTextBitstream.getPreferredSize() # gibt die bevorzugte Gr??e f?r das jetzt mit Text gef?llte Feld
                 prefSizeWindow = jframebitstream.getPreferredSize()
                 jframebitstream.setSize(frameWidth,int(prefSizeWindow.getHeight())+offset)
#                 print "3a",jframebitstream.jScrollPane1.getPreferredSize()
#                 print "3b",prefSizeTextArea
#                 print "3c",prefSizeWindow
#                 print "3d",frameWidth
                 #jframebitstream.jTextBitstream.setSize(frameWidth,int(prefSizeTextArea.getHeight())+offset)
                 jframebitstream.setSize(frameWidth+frameWidthButtonWindow,int(prefSizeTextArea.getHeight())+offset)
                 #jframebitstream.revalidate()
                 #jframebitstream.pack() # ACHTUNG pack verkleinert die Fenstergr??e auf optimale Ma?e nach Meinung von Swing ;-)
#                 print "3e",jframebitstream.getSize()
                
            jframebitstream.setVisible(True)
            
        else: # wenn Bitstream-Show AUS ist
            
            # den Einlesen Button UNsichtbar machen
            jframeActionButtons.jButtonBitstreamEinlesen.setEnabled(False)
            jframeActionButtons.jButtonBitstreamCopy.setEnabled(False)
            jframeActionButtons.jButtonBitstreamFromClipboard.setEnabled(False)
            
            jframebitstreamlocation = jframebitstream.getLocation() # Position des Bitstream-Fensters merken
            jframebitstreamsize = jframebitstream.getSize()
            jframebitstream.setVisible(False)
          
# Event f?r die Tasteneingabe im Bitsream-Fenster Textfeld
def bitstreamKeyReleased(event): # nur der Released Event zaehlt richtig!
    
    bitstreamfield=jframebitstream.jTextBitstream.getText()
    
    if len(bitstreamfield) != bitstreamlaenge:
        labelbitstreamtext = "<html><center>Laenge des Bitstreams: "+str(len(bitstreamfield))+ " Erforderliche Laenge: "+str(bitstreamlaenge)
    else:
        labelbitstreamtext = "<html><center>Laenge des Bitstreams: "+str(len(bitstreamfield))+ " (OK)"
    jframebitstream.jLabelBitstream.setText(labelbitstreamtext)


# ------------------------------------ Menu INFO
def aboutOnKlick(event):
    
    aboutDialog.setVisible(True)
    return

def makeFrame(): # erzeugt das App- Fenster NOT working! nur aus Anschauungsgr?nden noch enthalten
    pass

def initGUI():
    pass

    
#  --------- GLOBAL defs
def makegrids():
    global mygrid
    global dateigrid
    global zeilengrid
    #----------------  die GRIDS ----------------------
    
    # ohne Navbalken
    # Grid f?r Schwarz/Weiss
    mygrid=GameGrid(SPALTEN_KONST, ZEILEN_KONST, ZellenGroesse, False, keyPressed = onKeyPressed, mousePressed = pressCallbackMyGrid) # Spielfenster mit 8 x 8 Zellen der Gr?????sse 20 mit schwarzer Zellumrandung
    # nach http://clab6.phbern.ch/tigerjythonforum/viewthread.jsp?mid=143&
    # wenn der Closed Event ausgel?st wird
    mygrid.addExitListener(onCloseClicked)
    # Grid f?r die Zeilennummern
    zeilengrid=GameGrid(1, ZEILEN_KONST, ZellenGroesse, False) # f?r die Anzeige der Zeilennummern
    zeilengrid.addExitListener(onCloseClicked)
    # Grid f?r den Speicherinhalt 0/1
    dateigrid=GameGrid(SPALTEN_KONST, ZEILEN_KONST, ZellenGroesse, False, keyPressed = onKeyPressed, mousePressed = pressCallbackDateiGrid) # Spielfenster mit 8 x 8 Zellen der Gr?????sse 20 mit schwarzer Zellumrandung
    dateigrid.addExitListener(onCloseClicked)
    dateigrid.setFont(SPEICHERFONT)  

###################  *******************  main ********************************************************



# auf welchem BS laufen wir?
system = ""
ver = get_os_version()
if ver.startswith('windows'): # falls es windows ist
    system = "windows"
else:
    system = ver

taste=0 # Tastenvariable initialisieren

# Fensterobjekt erzeugen
# folgendes bei Start ?ber TigerJython
newJframe = NewJFrame(defaultCloseOperation=JFrame.DISPOSE_ON_CLOSE)
# folgendes nur bei standalone!
#newJframe = NewJFrame(defaultCloseOperation=JFrame.EXIT_ON_CLOSE) # schliesst auch das TigerJython-Fenster, nur bei standalsone benutzen!

# Fenster f?r die Buttons und den Nachrichtentext erzeugen
jframeActionButtons = JFrameActionButtons(defaultCloseOperation=JFrame.DISPOSE_ON_CLOSE)
#newJframe = NewJFrame(defaultCloseOperation=JFrame.EXIT_ON_CLOSE) # schliesst auch das TigerJython-Fenster, nur bei standalsone benutzen!


# das Start-Dialog-Fenster erzeugen und anzeigen
startDialog = NewOkCancelDialog(newJframe,True)
startDialog.setLocationRelativeTo(newJframe); 

startDialog.jRadioButton4bit.setSelected(True) # 4bit Button als Standardauswhl

startDialog.jCheckBox1.setVisible(False)

startDialog.setVisible(True)

# wartet bis Dialog geschlossen oder Cancel
#result = startDialog.dispose()
#print result

# Debug
#print startDialog.jSlider1.value
#print startDialog.jSlider2.value
#print startDialog.result
#print startDialog.RET_OK

# Auswerten der Eingaben
# startDialog.result == -1 es wurde ABBRECHEN gedr?ckt
# result == 1 , OK
# gilt f?r alle Dialoge

if startDialog.result != -1: # wenn nicht gecancelt, also nur wenn "weiter" gedr?ckt wurde, sonst Abbruch
  
     #----- die DIALOGE -----------------------------------------
    
    # Vorauswahl ?berpr?fen
    fourBit = int(startDialog.jRadioButton4bit.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    eight8Bit = int(startDialog.jRadioButton8bit8.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    eightBit = int(startDialog.jRadioButton8bit.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    sixteenBit = int(startDialog.jRadioButton16bit.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
    
    if fourBit:
        spalten = 4
        zeilen = 16
        ZellenGroesse = 40 # Hinweis: ZellenGroesse von 20 ist ein guter Standard f?r die meisten Aufl?sungen
        
    elif eight8Bit:
            spalten = 8
            zeilen = 8
            ZellenGroesse = 40 # Hinweis: ZellenGroesse von 20 ist ein guter Standard für die meisten Auflösungen
             

    elif eightBit:
            spalten = 8
            zeilen = 32
            ZellenGroesse = 30 # Hinweis: ZellenGroesse von 20 ist ein guter Standard für die meisten Aufl?sungen
            
    
    elif sixteenBit:
            spalten = 16
            zeilen = 32
            ZellenGroesse = 20 # Hinweis: ZellenGroesse von 20 ist ein guter Standard für die meisten Aufl?sungen

        
    else: 
        # ZellenGroesse des Speicher aus dem Startdialog holen
        # Slider1 sind die Spalte, slider2 die Zeilen   
        spalten = int(startDialog.jSlider1.value)
        zeilen = int(startDialog.jSlider2.value)
        ZellenGroesse = int(startDialog.jSlider3.value) # Hinweis: ZellenGroesse von 20 ist ein guter Standard für die meisten Auflösungen
        
    maximiert = int(startDialog.jCheckBox1.selected) # wird 1, wenn Checkbox aktiviert, 0 sonst
       
    bitstreamlaenge = spalten * zeilen
    
    #### TEST - funktioniert!
#    newJframe.removeAll()
#    newJframe.dispose()
#    del newJframe
    
    # Fensterobjekt erzeugen
    #newJframe = NewJFrame(defaultCloseOperation=JFrame.DISPOSE_ON_CLOSE)
    
    # ABOUT-Dialog
    aboutDialog = NewAboutJDialog(newJframe,True) 
    aboutDialog.setLocationRelativeTo(newJframe)
    aboutDialog.jTextArea1.setEditable(False)
    
    # ABOUT-Dialog
    aboutDialog = NewAboutJDialog(newJframe,True) 
    aboutDialog.setLocationRelativeTo(newJframe)
    aboutDialog.jTextArea1.setEditable(False)
    #aboutDialog.jTable1.setEditable(False)
    
    #aboutDialog.jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF)
    aboutDialog.jTable1.getColumnModel().getColumn(0).setPreferredWidth(100)
    #aboutDialog.jTable1.getColumnModel().getColumn(0).setMaxWidth(100)
    
    # JTable ZUgriff proben
    aboutDialog.jTable1.setValueAt(versionsnummer,0,1) # zeile, spalte, beginnend bei 0
    aboutDialog.jTable1.setValueAt(autor,1,1)
    aboutDialog.jTable1.setValueAt(lizenz,2,1)
    
    # MESSAGE-Dialog
    messageDialog = jDialogMessage(newJframe,True)
    messageDialog.setLocationRelativeTo(newJframe)
    #messageDialog.setVisible(True)
    #print messageDialog
      
                    
    # ÖFFNEN Dialog, aus historischen Gründen noch original benannt    
    newfiledialog = NewJFileDialog(newJframe,True)
   
    # das User Verzeichnis holen
    #dir_path = os.path.dirname(os.path.realpath(__file__))
    # dies ist notwendig, um den Path als String in ein jav.io.File Objekct zu casten!
   # homedir = File(dir_path)
    # um diesen dann im FileChooser weiter zu verwenden
    # Hintergrund ist, dass der User immer nur das aktuelle Arbeitsverzeichnis sehen soll!
    #newfiledialog.jFileChooser1.setCurrentDirectory(homedir)    

    #  SPEICHERN-Dialog
    newfilesavedialog = NewJFileSaveDialog(newJframe,True)
    #newfilesavedialog.jFileChooser2.setCurrentDirectory(homedir) 
 
    # --------  TOOOLKIT Bereich ---------------------------------------------------------------
    # toolkit = Toolkit.getDefaultToolkit()
    screenDimension = Toolkit.getDefaultToolkit().getScreenSize()
    screenWidth = int(screenDimension.getWidth())
    screenHeight = int(screenDimension.getHeight())
    
    #spalten = 4 # von 1 an zu zaehlen!
    SPALTEN_KONST = spalten
    #zeilen = 16 # von 1 an zu zaehlen!
    ZEILEN_KONST = zeilen
    #ZellenGroesse = 30 # WvS Beamer Aufloesung Raum 208
    hoehegrid = ZellenGroesse * (zeilen+1) # Berechnung der H?he des Grids
    #print "Hoehe grid:", hoehegrid
    breitegrid = ZellenGroesse * (spalten+1) # Berechnung der H?he des Grids
    #print "Breite grid:", breitegrid
    
    # 800 x 600 f?r Beamer 208
    FENSTERBREITE = screenWidth -100
    FENSTERHOEHE = screenHeight -100
    
    LEFT_KORR =50
    
    # Fenster Titel vorbereiten
    #fensterTitel = "Codierung von Informationen - FensterZellenGroesse: "+str(FENSTERBREITE)+" x "+str(FENSTERHOEHE)
    #fensterTitel = "Codierung von Informationen: "+str(ZEILEN_KONST)+" Speicheradressen mit je "+str(SPALTEN_KONST)+" bit Datenbreite"
    fensterTitel = str(ZEILEN_KONST)+" Adressen, je "+str(SPALTEN_KONST)+" bit Datenbreite"
    fensterTitelActionButtons = "Codierung von Informationen mit dem Programm bitmuster"
    
    # und setzen
    runswing(newJframe.setTitle(fensterTitel))
    jframeActionButtons.setTitle(fensterTitelActionButtons)
    
    # zusätzlich Ausgabe in das Nachrichtenfeld
    hinweis = "Codierung von Informationen. Der "+str(ZEILEN_KONST)+"x"+str(SPALTEN_KONST)+"bit-Speicher wurde erstellt mit "+str(ZEILEN_KONST)+" Speicheradressen von je "+str(SPALTEN_KONST)+" bit Datenbreite"
    jframeActionButtons.jTextFieldStatusBar.setForeground(Color.WHITE)
    jframeActionButtons.jTextFieldStatusBar.setBackground(Color.BLACK)
    jframeActionButtons.jTextFieldStatusBar.setText(hinweis)
    
    
    # aufgrund der Berechnungen f?r die Grids die neue Fensterbreite und h?he bestimmen
    rechterRand = 150
    hoehenMargin = 150
    fensterbreite = 20 + 2 * breitegrid + rechterRand
    if fensterbreite > FENSTERBREITE:
        
        fensternachricht = "Bildschirm ist f?r die Darstellung nicht gross genug! Bitte andere Speichergr??e w?hlen!"
        messageDialog.jLabelMessage.setText(fensternachricht)
        messageDialog.setVisible(True)
        
        
    fensterhoehe = hoehegrid + hoehenMargin
    #newJframe.setSize(fensterbreite,fensterhoehe)

    # ------ CLOSING EVENT-----------------
    newJframe.windowClosing = mainWindowClosing
    
    # --------------  M E N U events  --------------
    
    # da NEU nicht funktioniert, existiertd er Men?punkt zwar, wird aber nicht angezeigt
    # UND ist in der GUI zus?tzlich noch disabled
    #newJframe.jMenuNeu.setVisible(False) # da es nicht funktioniert, existiertd der Men?punkt zwar, wird aber nicht angezeigt UND ist in der GUI zus?tzlich noch disabled
    #newJframe.jMenuNeu.actionPerformed=newOnKlick
    
    # ActionButtonFrame
    #print(newJframe.jMenuLaden)
    newJframe.jMenuLaden.actionPerformed=textDateiEinlesenOnKlick
    newJframe.jMenuSpeichern.actionPerformed=textDateiSpeichernOnKlick
    newJframe.jMenuAnalyse.actionPerformed=textDateiAnalyseOnKlick
    newJframe.jMenuBeenden.actionPerformed=runswing(quitOnKlick)
    
    # Menu Operationen
    newJframe.jMenuOperationLoeschen.actionPerformed=runswing(speicherLoeschenOnKlick)
    newJframe.jMenuOperationFuellen.actionPerformed=runswing(speicherFuellenOnKlick)
    newJframe.jMenuOperationZufallsFuellen.actionPerformed=runswing(speicherZufallsFuellenOnKlick)
    newJframe.jMenuOperationInvert.actionPerformed=runswing(speicherInvertOnKlick)
    newJframe.jMenuOperationRotateLeft.actionPerformed=runswing(speicherRotateLeftOnKlick)
    newJframe.jMenuOperationRotateRight.actionPerformed=runswing(speicherRotateRightOnKlick)
    newJframe.jMenuOperationShiftLeft.actionPerformed=runswing(speicherShiftLeftOnKlick)
    newJframe.jMenuOperationShiftRight.actionPerformed=runswing(speicherShiftRightOnKlick)
    
    # Menu Bitstreams
    newJframe.jMenuBitstreamDateiLaden.actionPerformed=runswing(bitstreamDateiEinlesenOnKlick)
    newJframe.jMenuBitstreamSpeicherAnhaengen.actionPerformed=runswing(bitstreamSpeicherAnhaengenOnKlick)
    newJframe.jMenuBitstreamDateiPlay.actionPerformed=runswing(bitstreamDateiPlayOnKlick)
    #newJframe.jCheckBoxMenuBitstreamsRepeat=runswing(bitstreamsRepeatCheckBoxOnKlick)
    #newJframe.jMenuBitstreamSpeicherAnhaengen.actionPerformed=runswing(bitstreamSpeicherAnhaengenOnKlick)
    
    # diese  Menupunkte sind solange disabled, bis eine Datei erfolgreich geladen wurde!
    newJframe.jMenuBitstreamSpeicherAnhaengen.setEnabled(False)
    newJframe.jMenuBitstreamDateiPlay.setEnabled(False)
    newJframe.jCheckBoxMenuBitstreamsRepeat.setEnabled(False)
    newJframe.jCheckBoxMenuBitstreamsRepeat5.setEnabled(False)
    newJframe.jRadioButtonBitstream005Sekunden.setEnabled(False)
    newJframe.jRadioButtonBitstream01Sekunden.setEnabled(False)
    newJframe.jRadioButtonBitstream02Sekunden.setEnabled(False)
    newJframe.jRadioButtonBitstream05Sekunden.setEnabled(False)
    
    
    # zus?tzlich verbergen, da noch zu aufw?ndig implementierbrar
    newJframe.jMenuBitstreamSpeicherAnhaengen.setVisible(False)
    
    
    # About Menu
    newJframe.jMenuAboutItem.actionPerformed=aboutOnKlick
      
    
    # ---------------  BUTTONS / CHeckBoxes / ComBoBox  -----------------------------
    
    #nAction Buttons Frame
    jframeActionButtons.jButton1.actionPerformed=quitOnKlick
    # erstmal verstecken, da jetzt die Operationen die Aufgabe ?bernehmen
    #jframeActionButtons.jButtonBitstreamZufall.setVisible(False) 
    
    jframeActionButtons.jCheckBitstream.actionPerformed=showBitStreamOnKlick
    jframeActionButtons.jButtonBitstreamEinlesen.actionPerformed=bitstreamEinlesenOnKlick
    jframeActionButtons.jButtonBitstreamCopy.actionPerformed=bitstreamCopyOnKlick
    jframeActionButtons.jButtonBitstreamFromClipboard.actionPerformed=bitstreamFromClipboardOnKlick
    
    # -- die ComboBox f?r die Zeilen
    jframeActionButtons.jComboBox1.removeAllItems() # erstmal alle m?glicherwiese voranden Eintr?ge entfernen
    for zeilennummer in range(ZEILEN_KONST):
        jframeActionButtons.jComboBox1.addItem(str(zeilennummer)) # und die Zeilennnummern hinzuf?gen
    jframeActionButtons.jComboBox1.maximumRowCount = 10 # Anzahl der angezeigten Eintr?ge
    
    # Zeile ausgeben Button   
    jframeActionButtons.jButtonZeileAusgeben.actionPerformed=zeileAusgebenOnKlick
    
    # ---------------  Textfelder INIT-----------------------------
    
    backgroundcolor = newJframe.getBackground()
    
    jframeActionButtons.jTextFieldStatusBar.setWrapStyleWord(True) # Zeilenumbruch in der Textarea f?r die Messages nach WORT
       
    showBitstream = False # Boolean, ob Bitstream sichtbar True oder nicht False
    
    
#    #----------------  die GRIDS ----------------------
#    
#    # ohne Navbalken
#    # Grid f?r Schwarz/Weiss
#    mygrid=GameGrid(SPALTEN_KONST, ZEILEN_KONST, ZellenGroesse, False, keyPressed = onKeyPressed, mousePressed = pressCallbackMyGrid) # Spielfenster mit 8 x 8 Zellen der Gr?????sse 20 mit schwarzer Zellumrandung
#    # nach http://clab6.phbern.ch/tigerjythonforum/viewthread.jsp?mid=143&
#    # wenn der Closed Event ausgel?st wird
#    mygrid.addExitListener(onCloseClicked)
#    # Grid f?r die Zeilennummern
#    zeilengrid=GameGrid(1, ZEILEN_KONST, ZellenGroesse, False) # f?r die Anzeige der Zeilennummern
#    zeilengrid.addExitListener(onCloseClicked)
#    # Grid f?r den Speicherinhalt 0/1
#    dateigrid=GameGrid(SPALTEN_KONST, ZEILEN_KONST, ZellenGroesse, False, keyPressed = onKeyPressed, mousePressed = pressCallbackDateiGrid) # Spielfenster mit 8 x 8 Zellen der Gr?????sse 20 mit schwarzer Zellumrandung
#    dateigrid.addExitListener(onCloseClicked)
#    dateigrid.setFont(SPEICHERFONT)
    makegrids()
    # MIT Navbalken
    #makeGameGrid(spalten, zeilen, ZellenGroesse, True, keyPressed = onKeyPressed, mousePressed = pressCallback) # Spielfenster mit spalten x zeilen Zellen der Gr?????sse ZellenGroesse mit schwarzer Zellumrandung
    #addStatusBar(100)
    #setStatusText("Fenster muss aktiv(iert) sein,\num Tasten zu erkennen.\nEinfach mit der Maus\nin diesen Bereich klicken.\nDann Taste druecken.\nESC zum Beenden!",Font("SansSerif",Font.PLAIN,10),Color.black)
    
    # das Layout f?r jedes GridPanel festlegen, so dass die Grids immer mittig im Panel angeordnet werden
    # hier ergibt sichm?glicherweise das center des Beschriftungslabels im Border North!
    #gridlayout = BorderLayout() 
    ############
    newJframe.getContentPane().add(newJframe.jPanel1, java.awt.BorderLayout.WEST); # dies ist wichtig, da hier die gesamten Grids im Westfl?gel fixiert(!) sind
    ############# 
    # von links nach rechts durchgehen
    
    # ---------------  ZeilenGrid -----------------
    runswing(zeilengrid.setBgColor(Color.GRAY))
    bgzeile = zeilengrid.getBg()
    bgzeile.setPaintColor(Color.white)
    runswing(fillZeilenGrid(zeilengrid))
    
    #zeilengrid.setSimulationPeriod(10000)
    
    #newframe.jPanel1.add(zeilengrid)
    
    #newJframe.jPanel1.setLayout(gridlayout)
    
    newJframe.jPanel1.add(zeilengrid,BorderLayout.WEST) # da die grids awt canvas sind, sollte das funktionieren
    #newJframe.jPanel1.add(zeilengrid) 
        
    # ---------------  DateiGrid erzeugen -----------------
    backgroundcolor = newJframe.getBackground()
    dateigridColor = backgroundcolor
    #dateigridColor = Color.lightGray
    runswing(dateigrid.setBgColor(dateigridColor))
    bgdatei = dateigrid.getBg()
    runswing(bgdatei.setPaintColor(Color.black))
    
    
    
#    dateigridpanel = JPanel()
#    dateigridpanel.setBounds(30, 30, 300, FENSTERHOEHE-100) # (x,y,Breite, H?HE)
#    dateigridpanel.add(dateigrid)
#    
#    dateiScrollPane = JScrollPane(dateigridpanel)
    #dateiScrollPane.preferredSize = 100, 200
    #dateiScrollPane.viewport.view = dateigrid
    #dateigridpanel.add(dateiScrollPane) 
    
    #cp.add(dateigridpanel)
    
    #dateigrid.setSimulationPeriod(1000)
    
    #newJframe.jPanel2.setLayout(gridlayout)
    #newJframe.jPanel2.add(dateigrid,BorderLayout.CENTER)
    newJframe.jPanel1.add(dateigrid,BorderLayout.CENTER) 
    #newJframe.jPanel2.add(dateigrid)
    
    #newJframe.jPanel2.dateigrid.setHorizontalAlignment(SwingConstants.CENTER)
    
    
    #dateigridcomponent[0].setHorizontalAlignment(SwingConstants.CENTER)
    
    # ---------------  MyGrid erzeugen -----------------
#    mygridpanel = JPanel()
#    
#    mygridpanel.setBounds(350, 30, 300, FENSTERHOEHE-100) # (x,y,Breite, H?HE)
#    
#    mygridScrollPane = JScrollPane(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
#                                     JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED)
    #mygridScrollPane.preferredSize = 100, 200
    #newframe.jPanel2.viewport.view = mygrid
    #newframe.jPanel3.add(mygrid)
    #mygridpanel.add(mygrid)
    #cp.add(mygridpanel)
    #mygrid.setSimulationPeriod(1000)
    runswing(mygrid.setBgColor(Color.WHITE)) # Hintergrundfarbe auf weiss setzen
    bg = mygrid.getBg()
    #bg.setFont(Font("Arial",0,8)) # font type, style, size
    
    # TEST wegen s.u.
    runswing(mygrid.revalidate())
    
    #newJframe.jPanel3.setLayout(gridlayout)
    #newJframe.jPanel1.add(newJframe.jPanel3,BorderLayout.EAST)
    newJframe.jPanel1.add(mygrid,BorderLayout.EAST)
    
    #newJframe.jPanel3.add(mygrid)
    # TEST
    #newJframe.jPanel1.add(mygrid,BorderLayout.EAST) 
    
    
    #newJframe.jInternalFrame1.setNorthPane(None)
    # mygrid sitz in iframe jpanel3
    #### TEST jinternalkframe
    #newJframe.jInternalFrame1.revalidate()
    #newJframe.jInternalFrame1.pack()
    #newJframe.jInternalFrame1.setVisible(True)
    
      
    # --------------  FRAME Actions
  
    #newJframe.pack() # wichtig, um alle komponenten zu verbinden!
    
    #setTitle("Blinkenlights light")
    #setClosingMode(GameGrid.ClosingMode.NothingOnClose) # verhindern, dass das Fenster ?ber die TitleBar geschlossen werden kann!
    
   
    #show()
    #dateigrid.doRun() # warum einschalten? wenn es auch ohne geht...
    
    # INITIALISIERE SPeicher mit Null
    bitstream = (wert2bitstream(0)) # test mit der runnable Funktion
    runswing(bitstream2picture(bitstream)) # s.o.
    
    # 1 = schwarz an dieser Stelle, 0 = weiss (Hintergrund)
    farbe = Color.black # Zellfarbe von "1"
    
    # wie sieht das Bild aus?
    #initPicture(bitmuster) # Darstellung der Bitmuster
 
    # maximierung sinnvoll?
    if maximiert:
        newJframe.setExtendedState(JFrame.MAXIMIZED_BOTH);
    
    
     # ------------------ die Grids erstmalig synchronisieren
    runswing(getPicture2()) # test mit der runnable Funktion
    #refresh()
    # TEST f?r jar Aufruf Windows! - brachte keine direkte Verbesserung (Schritt 1)
    runswing(mygrid.refresh())
    runswing(dateigrid.refresh())
    
    # TEST stop GameThread - funktioniert trotzdem! spart angeblich CPU Zeit
    runswing(zeilengrid.stopGameThread())
    runswing(dateigrid.stopGameThread())
    runswing(mygrid.stopGameThread())
    
    #-----------
    # TEST vorher nur validate f?r jar Aufruf Windows! - noch keine Verbesserung (Schritt 2) da dateodrid erst nach fenster sizing angezeigt wird
#    zeilengrid.revalidate()
#    mygrid.revalidate()
#    dateigrid.revalidate()
    
    runswing(zeilengrid.validate())
    runswing(mygrid.validate())
    runswing(dateigrid.validate())
#    
#    mygrid.repaint() # test
    
    runswing(dateigrid.repaint()) # test f?r s.o (3)
    runswing(mygrid.repaint()) # test f?r s.o (3)
    runswing(zeilengrid.repaint()) # test f?r s.o (3)
    
    #newJframe.revalidate() # f?hrt zum Absturz?!
    #jTestField = JTextField("Hello, I am Nemo in a custom window")
    #newJframe.getContentPane().add(jTestField, BorderLayout.SOUTH)
    
#    newJframe.jPanel1.revalidate()
#    newJframe.jPanel2.revalidate()
#    newJframe.jPanel3.revalidate()
#    TEST f?r s.o. (4)
    #newJframe.jPanel1.revalidate()

    runswing(newJframe.jPanel1.validate())
    runswing(newJframe.jPanel1.repaint())
#    newJframe.jPanel2.repaint()
#    newJframe.jPanel3.repaint()
    #newJframe.GroundPanel.add(jframeActionButtons.jTextFieldStatusBar,BorderLayout.SOUTH)
    
    
    
    # ------------  HAUPT - Fenster -------------------
    # das HAUPTframe vorbereiten
    runswing(newJframe.validate()) # f?hrt zum Absturz?!
    #newJframe.revalidate() # f?hrt zum Absturz?!
    runswing(newJframe.pack()) # wichtig, um alle komponenten zu verbinden!
    runswing(newJframe.repaint())
    
    
    #print "frame pref:",newJframe.getPreferredSize()
    #print "frame size:",newJframe.getSize()
    
    
    # --------  BUTTON - Fenster ----------------
    # das Frame f?r die BUTTONS vorbereiten
    # die Daten des HAUPTfensters holen
    frameX =newJframe.getX()
    frameY =newJframe.getY()
    frameWidth = newJframe.getWidth()
    frameHeight = newJframe.getHeight()
    
    jframeActionButtons.pack() # beobachten, k?nnte Schwierigkeiten machen
    
    # Button Fenster die gleiche H?ge wie das Hauptfenster geben
    # das hat den Nachteil, dass manchmal das Fenster nicht hoch genug ist...    
    #runswing(jframeActionButtons.setSize(int(jframeActionButtons.getPreferredSize().getWidth()),frameHeight))
    
    # Button Fenster rechts vom aktuellen Fenster platzieren - mit etwas Abstand rechts
    runswing(jframeActionButtons.setLocation(frameX+frameWidth+15, frameY))
    
    
    jframeActionButtons.revalidate()
    
    jframeActionButtons.repaint()
       # und sichtbar machen
    jframeActionButtons.setVisible(True)
    
    #print "Buttonframe pref:",jframeActionButtons.getPreferredSize()
    #print "Buttonframe size:",jframeActionButtons.getSize()
    
    #newJframe.revalidate()
    
    # bringt nur ein extra Fenster das wir nicht wollen
    #dateigrid.show()
    
    
    # ---------  Bitstream- Fenster --------------
    jframebitstream = JFrameBitstream(defaultCloseOperation=JFrame.DISPOSE_ON_CLOSE)
    jframebitstream.setTitle("Bitstream-Anzeige (Inhalt der Adressen beginnend bei 0 wird als Stream von links nach rechts ausgegeben)")
    #jframebitstream.setResizable(False) # das Fenster kann nicht mehr resized werden - sinnvoll?? - irgendwie nicht
    
    jframebitstream.jTextBitstream.setLineWrap(True)
    
    jframebitstream.jTextBitstream.keyReleased = bitstreamKeyReleased # Tastenevent
    
    myborderlayout = BorderLayout()
    #jframebitstream.setLayout(myborderlayout)
    
    jframebitstream.setPreferredSize(None)
    jframebitstream.add(jframebitstream.jScrollPane1,BorderLayout.CENTER)
    #jframebitstream.revalidate()
    jframebitstreamlocation = 0  # Initialisierung von Position und Size des Bitstream-Fensters
    jframebitstreamsize = 0
        
    # das HAUPTframe vorbereiten
    
    #newJframe.setSize(int(frameWidth)+10,frameHeight+10) - n?tzt nichts bei win jar!
    
    #newJframe.setState(JFrame.ICONIFIED); # To minimize a frame
    #newJframe.setExtendedState(JFrame.MAXIMIZED_BOTH) # Maximize
    #delay(1000)
    
#         
    
#    newJframe.revalidate() # f?hrt zum Absturz?!
#    newJframe.pack() # wichtig, um alle komponenten zu verbinden!
#    newJframe.repaint()

    frameX = newJframe.getX()
    frameY = newJframe.getY()
    frameWidth = newJframe.getWidth()
    frameHeight = newJframe.getHeight()
    
    runswing(newJframe.setSize(frameWidth+10,frameHeight))
    
    # TEST Alternative f?r Windows? Funktioniert NICHT! es braucht tas?chlich ein MAX und verkleinerung danach
    #newJframe.resize(frameWidth+10,frameHeight)
    
    # das Abbruch-Flag
    quitKlickBool = False
    
    # jetzt erst das Fenster sichtbar machen
    runswing(newJframe.setVisible(True))
    
    # ENDLICH! das scheint es gewesen zu sein. Jetzt wird unter Windows ENDLICH alles richtig bim Start angezeigt
    # dieser Code braucht NUR unter Windows ausgef?hrt zu werden.
#    if system == "windows":
#        runswing(newJframe.setExtendedState(JFrame.MAXIMIZED_BOTH)) # TEST f?r Win! erst maximieren, dann 1000ms warten
#        mygrid.delay(5000) # reichen auch 500ms??
#        runswing(newJframe.setExtendedState(JFrame.NORMAL)) # Normal
    #print mygrid        
        
    while not(quitKlickBool): # 
        mygrid.delay(1000) # alle 2 Sekunden wird auf Beenden gepr?ft. Dadurch weniger CPU Zeit!
        pass
#         
#        #newJframe.pack() # TEST = Fenster l?sst sich nicht mehr ver?ndern
##        runswing(mygrid.refresh())
##        runswing(dateigrid.refresh())
#        
#        #mygrid.refresh()
#        #dateigrid.refresh()
#                       
        if quitKlickBool:
            # ALLES schliessen am Ende
            mygrid.dispose()
            dateigrid.dispose()
            zeilengrid.dispose()
            
            #cp.removeAll()
            newJframe.removeAll()
            newJframe.dispose()
            
            jframebitstream.removeAll()
            jframebitstream.dispose()
            
            jframeActionButtons.removeAll()
            jframeActionButtons.dispose()
            
            del mygrid
            del dateigrid
            del zeilengrid
            del newJframe
            del jframebitstream
            del jframeActionButtons
            
            break # unsch?n, aber hier notwendig
#

